      program uamv
c
c**********************************************************************
c                                                                     *
c                                                                     *
c  U R B A N   A I R S H E D   M O D E L                              *
c                                                                     *
c  V A R I A B L E - N E S T E D   G R I D   V E R S I O N (2/13/91)  *
c                                                                     *
c  C A R B O N   B O N D   M E C H A N I S M   V E R S I O N   IV     *
c                                                                     *
c                                                                     *
c  *** (c) Copr. 1992, 1999, 2002  Systems Applications International *
c                                                                     *
c                                                                     *
c**********************************************************************
c                                                                      
c
c     Developed By System Applications International
c                  101 Lucas Valley Road
c                  San Rafael, California  94903
c                  (415) 507-7100
c
c
c     any questions please contact : TOM MYERS
c
c======================================================================
c
c           the calling tree of the model is as follows:
c
C UAMV---------+GETARG
C              |-SETUP--------+LFTPAK
C              |              |-CALTOJ
C              |              |-PIGINIT-------CLLDIM--------FINTEG
C              |              |-HDRCHK
C              |              |-CHREAD--------FLUSH
C              |              |-TIRATE
C              |              |-RVMMAP-------+INTRVL
C              |              |              \ENDIND
C              |              |-RDFSRF
C              |              |-AHINTF
C              |              |-FLXNIT
C              |              |-ALLOC
C              |              |-HEDPTS
C              |              |-GUNIT--------+JTOCAL
C              |              |              \ZELLAR
C              |              |-HEDQAR
C              |              |-GETQAR-------+CALTOJ
C              |              |              \INTRVL
C              |              |-GETPT--------+CALTOJ
C              |              |              \INTRVL
C              |              |-EFTOT
C              |              |-GRDSP
C              |              |-HEDIBC
C              |              |-GETIC--------+CALTOJ
C              |              |              \INTRVL
C              |              |-HEDDV
C              |              |-UNCHEK
C              |              |-BNDDEF
C              |              |-RESTRT-------+CALTOJ
C              |              |              |-FGREAD
C              |              |              \INTRVL
C              |              |-PGREAD-------+CALTOJ
C              |              |              |-INTRVL
C              |              |              \PIGDMP-------+FLUSH
C              |              |                            \DMPPIG
C              |              |-PIGDMP-------+FLUSH
C              |              |              \DMPPIG
C              |              |-DIAGN--------+CHKDAT
C              |              |              \FLUSH
C              |              \UPDATE-------+JTOCAL
C              |                            |-CALTOJ
C              |                            |-RDFWND
C              |                            |-INTRVL
C              |                            |-HTFAGE
C              |                            |-FGRTRP
C              |                            |-RDFZP
C              |                            |-FFGTRP--------REDUCR
C              |                            |-RDFRN
C              |                            |-RDFTMP
C              |                            |-GETBC--------+CALTOJ
C              |                            |              \INTRVL
C              |                            |-CNVTBC
C              |                            |-GETHAZ-------+CALTOJ
C              |                            |              |-INTRVL
C              |                            |              \LFTPAK
C              |                            |-LFTPAK
C              |                            |-RDFKV
C              |                            |-RDFCLD
C              |                            |-RDFH2O
C              |                            |-CONVRT
C              |                            |-BEH084--------FLUSH
C              |                            |-DIFFUS
C              |                            |-DIAGN--------+CHKDAT
C              |                            |              \FLUSH
C              |                            |-CKHGT
C              |                            \HDRCHK
C              |-FLUSH
C              |-IRR_INIT0
C              |-IRR_INIT1
C              |-FINFIL
C              |-FGRTRP
C              |-PRTINT-------+FGWRIT
C              |              \FLUSH
C              |-SURLYR-------+JTOCAL
C              |              |-SOLAR
C              |              |-PBLMOD
C              |              |-AERODY
C              |              |-BNDRY
C              |              |-PRTDEP-------+SEDRAT
C              |              |              |-STOKE
C              |              |              \SHMIDT
C              |              \SURFCE-------+TDRATE
C              |                            \VAPSRC
C              |-SRLYRF-------+JTOCAL
C              |              |-SOLAR
C              |              |-PBLMOD
C              |              |-AERODY
C              |              |-BNDRY
C              |              |-PRTDEP-------+SEDRAT
C              |              |              |-STOKE
C              |              |              \SHMIDT
C              |              \SURFCE-------+TDRATE
C              |                            \VAPSRC
C              |-DTSIZE
C              |-AVERAG
C              |-AVERGF
C              |-GET_FINAL
C              |-IRR_WRT-------FLUSH
C              |-IRR_WRTF------FLUSH
C              |-XTIME
C              |-JTOCAL
C              |-NDAYAD
C              |-CALTOJ
C              |-INTRVL
C              |-MASCAL
C              |-FMSCAL
C              |-XMSCAL
C              |-XMSPRT
C              |-FMSPRT
C              |-MASFLO
C              |-PLGMAS--------CONVRT
C              |-INJECT--------GET_DIFC------IRR_CONC------FLUSH
C              |-EMCORS-------+GET_DIFC------IRR_CONC------FLUSH
C              |              \CONVRT
C              |-HGTNEW
C              |-VERTWD
C              |-BDRFIL
C              |-XMSFLO
C              |-STEPX--------+TERMS--------+JTOCAL
C              |              |              |-SOLAR
C              |              |              \WETDEP
C              |              \SMOLAR
C              |-STEPY---------SMOLAR
C              |-CALVDF
C              |-FSTEP---------FGMAX
C              |-DIFFSF
C              |-HTFCAL
C              |-FVRTWD
C              |-INJECTF
C              |-EMFINE--------CONVRT
C              |-FMSFLO
C              |-FBDFIL--------ARRGET
C              |-TERMSF-------+JTOCAL
C              |              |-SOLAR
C              |              \WETDEPF
C              |-STEPXF--------SMOLAR
C              |-STEPYF--------SMOLAR
C              |-CLVDFF
C              |-RCHEMF-------+JTOCAL
C              |              |-TDRATE
C              |              |-PHOTF---------SOLAR
C              |              |-STEP4F-------+TITRAT
C              |              |              |-CHEM2BF------+RADJRAT_2BF
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2BF
C              |              |              |              \FASTJAC_2BF
C              |              |              |-CHEM2A1F-----+RADJRAT_2A1F
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2A1F
C              |              |              |              \FASTJAC_2A1F
C              |              |              |-CHEM2A2F-----+RADJRAT_2A2F
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2A2F
C              |              |              |              \FASTJAC_2A2F
C              |              |              |-CHEMA--------+RADJRAT
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_A
C              |              |              |              \FASTJAC_A
C              |              |              |-FLUSH
C              |              |              |-COLPIVOT
C              |              |              |-SLOWNTB
C              |              |              |-SLOWNTA2
C              |              |              |-SLOWNTA1
C              |              |              \SLOWDR
C              |              \STEP4--------+TITRAT
C              |                            |-CHEM2B-------+RADJRAT_2B
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2B
C              |                            |              \FASTJAC_2B
C              |                            |-CHEM2A1------+RADJRAT_2A1
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2A1
C              |                            |              \FASTJAC_2A1
C              |                            |-CHEM2A2------+RADJRAT_2A2
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2A2
C              |                            |              \FASTJAC_2A2
C              |                            |-CHEM---------+RADJRAT
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE
C              |                            |              \FASTJAC
C              |                            |-FLUSH
C              |                            |-IRR_RATE
C              |                            \COLPIVOT
C              |-NSTFIL
C              |-CRSFIL--------GET_DIFC------IRR_CONC------FLUSH
C              |-RCHEM--------+JTOCAL
C              |              |-GET_DIFC------IRR_CONC------FLUSH
C              |              |-TDRATE
C              |              |-PHOT----------SOLAR
C              |              |-STEP4F-------+TITRAT
C              |              |              |-CHEM2BF------+RADJRAT_2BF
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2BF
C              |              |              |              \FASTJAC_2BF
C              |              |              |-CHEM2A1F-----+RADJRAT_2A1F
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2A1F
C              |              |              |              \FASTJAC_2A1F
C              |              |              |-CHEM2A2F-----+RADJRAT_2A2F
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_2A2F
C              |              |              |              \FASTJAC_2A2F
C              |              |              |-CHEMA--------+RADJRAT
C              |              |              |              |-COLPIVOT
C              |              |              |              |-FLUSH
C              |              |              |              |-FASTRATE_A
C              |              |              |              \FASTJAC_A
C              |              |              |-FLUSH
C              |              |              |-COLPIVOT
C              |              |              |-SLOWNTB
C              |              |              |-SLOWNTA2
C              |              |              |-SLOWNTA1
C              |              |              \SLOWDR
C              |              \STEP4--------+TITRAT
C              |                            |-CHEM2B-------+RADJRAT_2B
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2B
C              |                            |              \FASTJAC_2B
C              |                            |-CHEM2A1------+RADJRAT_2A1
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2A1
C              |                            |              \FASTJAC_2A1
C              |                            |-CHEM2A2------+RADJRAT_2A2
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE_2A2
C              |                            |              \FASTJAC_2A2
C              |                            |-CHEM---------+RADJRAT
C              |                            |              |-COLPIVOT
C              |                            |              |-FLUSH
C              |                            |              |-FASTRATE
C              |                            |              \FASTJAC
C              |                            |-FLUSH
C              |                            |-IRR_RATE
C              |                            \COLPIVOT
C              |-TTRAJ--------+TRJSTP
C              |              |-FKINDX
C              |              |-EXPAND-------+SIGMAY
C              |              |              \SIGMAZ
C              |              |-EXPANDF------+SIGMAY
C              |              |              \SIGMAZ
C              |              |-SETPRM
C              |              |-RPM----------+JTOCAL
C              |              |              |-EULER---+AMBIEN
C              |              |              |         \DEVCON
C              |              |              |-DOCHEM--+TDRATE
C              |              |              |         |-PHOT-----SOLAR
C              |              |              |         |-SSDARK---CHM23S
C              |              |              |         |-SSDAY----CHEMS-----+FLUSH
C              |              |              |         |                    |-CHRT1S
C              |              |              |         |                    \CHRT3S
C              |              |              |         |-STEP4F--+TITRAT
C              |              |              |         |         |-CHEM2BF---+RADJRAT_2BF
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2BF
C              |              |              |         |         |           \FASTJAC_2BF
C              |              |              |         |         |-CHEM2A1F--+RADJRAT_2A1F
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2A1F
C              |              |              |         |         |           \FASTJAC_2A1F
C              |              |              |         |         |-CHEM2A2F--+RADJRAT_2A2F
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2A2F
C              |              |              |         |         |           \FASTJAC_2A2F
C              |              |              |         |         |-CHEMA-----+RADJRAT
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_A
C              |              |              |         |         |           \FASTJAC_A
C              |              |              |         |         |-FLUSH
C              |              |              |         |         |-COLPIVOT
C              |              |              |         |         |-SLOWNTB
C              |              |              |         |         |-SLOWNTA2
C              |              |              |         |         |-SLOWNTA1
C              |              |              |         |         \SLOWDR
C              |              |              |         |-STEP4---+TITRAT
C              |              |              |         |         |-CHEM2B----+RADJRAT_2B
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2B
C              |              |              |         |         |           \FASTJAC_2B
C              |              |              |         |         |-CHEM2A1---+RADJRAT_2A1
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2A1
C              |              |              |         |         |           \FASTJAC_2A1
C              |              |              |         |         |-CHEM2A2---+RADJRAT_2A2
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE_2A2
C              |              |              |         |         |           \FASTJAC_2A2
C              |              |              |         |         |-CHEM------+RADJRAT
C              |              |              |         |         |           |-COLPIVOT
C              |              |              |         |         |           |-FLUSH
C              |              |              |         |         |           |-FASTRATE
C              |              |              |         |         |           \FASTJAC
C              |              |              |         |         |-FLUSH
C              |              |              |         |         |-IRR_RATE
C              |              |              |         |         \COLPIVOT
C              |              |              |         \DEVCON
C              |              |              |-SWITCH
C              |              |              \INITLZ-----DEVCON
C              |              \PUFFDMP-------DELTAZ
C              |-GETPT--------+CALTOJ
C              |              \INTRVL
C              |-HEDPTS
C              |-UPDATE-------+JTOCAL
C              |              |-CALTOJ
C              |              |-RDFWND
C              |              |-INTRVL
C              |              |-HTFAGE
C              |              |-FGRTRP
C              |              |-RDFZP
C              |              |-FFGTRP--------REDUCR
C              |              |-RDFRN
C              |              |-RDFTMP
C              |              |-GETBC--------+CALTOJ
C              |              |              \INTRVL
C              |              |-CNVTBC
C              |              |-GETHAZ-------+CALTOJ
C              |              |              |-INTRVL
C              |              |              \LFTPAK
C              |              |-LFTPAK
C              |              |-RDFKV
C              |              |-RDFCLD
C              |              |-RDFH2O
C              |              |-CONVRT
C              |              |-BEH084--------FLUSH
C              |              |-DIFFUS
C              |              |-DIAGN--------+CHKDAT
C              |              |              \FLUSH
C              |              |-CKHGT
C              |              \HDRCHK
C              |-RVMMAP-------+INTRVL
C              |              \ENDIND
C              |-GUNIT--------+JTOCAL
C              |              \ZELLAR
C              |-GETQAR-------+CALTOJ
C              |              \INTRVL
C              |-HEDQAR
C              |-EFTOT
C              |-PRINTR-------+JTOCAL
C              |              |-NDAYSUB
C              |              |-CALTOJ
C              |              |-FGAVWR
C              |              |-FGWRIT
C              |              |-GXYWR
C              |              \FLUSH
C              |-PGWRIT-------+PIGDMP-------+FLUSH
C              |              |              \DMPPIG
C              |              \FLUSH
C              |-XCMPRT
C              |-FCMPRT
C              \CUMPRT
c
c-----------------------------------------------------------------------
c                                                                      |
c       modification history:                                          |
c
c    version 0.02 created from v 0.01 with following changes:
c   
c      1.  added capability to use u and v on staggered grid as
c          an option to standard cell centered grid.  changes in 
c          aaamain, smolar, stepx, stepxf, stepy, 
c          and stepyf.  (tcm, 07/08/91) 
c 
c    version 0.03 created from v 0.02 with following changes: 
c   
c      2.  interpolation of pressure and temperature added
c          before initialization of fine grid average concs
c          to avoid nans in average file.  (tcm, 8/19/91)
c
c      3.  interpolation of fine grid heights inserted in
c          update after read of hnew so that htf is defined
c          before calling rdfkv.  (tcm, 8/23/91)
c
c    version 0.04 created from v 0.03 with following changes:
c   
c      4.  time step calculation moved from surlyr to separate
c          routine dtsize.  (tcm, 9/30/91)
c
c      5.  dry deposition updated according to review by 
c          joseph scire, dated 8/23/91 (tcm, cae, 10/10/91)
c      
c      6.  stack and point emissions files combined into a single
c          input file with format as in uam doc.  input timing
c          for all emissions files revised to be independent of
c          print interval.  (tcm, 10/10/91)
c
c      7.  plume rise upgraded to beh084.  (cae, 10/10/91)
c
c    version 0.10 created from v 0.04 with following changes:
c
c      8.  evaporating onion-skin plume-in-grid (pig) treatment 
c          incorporated, based on the paris model.  (tcm, cae, 
c          11/20/91)
c
c      9.  dry deposition rates removed from "decay" variable, 
c          where depositing material was removed in x-advection 
c          routine stepx.  dry deposition fluxes are now used as the 
c          surface boundary condtion for vertical diffusion 
c          (cae, 11/6/91) 
c                                                                      
c     10.  temperature and pressure added as static arrays for each
c          fine grid; respective calls to fgrtrp for arrays temper and
c          press have been moved from main to update (cae, 12/31/91)
c
c    version 1.00 created from v 0.10 with following changes:
c
c     11.  moved some arguments in chemistry rates routines to 
c          common block ratcom to speed execution (tcm, 1/30/92)
c
c     12.  added photostationary chemistry calculations as option
c          in pig treatment (bxs, tcm, 1/30/92)
c
c     13.  added input and output restart files for pig (tcm, 2/5/92)
c
c    version 1.01 created from v 1.00 with following changes:
c
c     14.  fixed subscript in 185 loop in step4 so that if conc
c          is less than lower bound rate will be set to zero.
c          (tcm, 2/24/92)
c
c     15.  moved calculation of deposition flux for flux summary
c          table out of stepx and stepxf into calvdf and clvdff.
c          also mods to vrtdif and aaamain to accomplish this.
c          (tcm, 2/25/92)
c
c    version 1.02 created from v 1.01 with following changes:
c
c     16.  fixed misspelling of variables in diagnostic prints and
c          cleaned up some variable declarations in several 
c          routines (clldim, dochem, emcors, emfine, rchem, rchemf,
c          restrt, ssdark, step4, termsf, and titrat).  
c          (tcm, 4/6/92)
c
c     17.  explicitly specifiy form = unformatted in opens of 
c          fine grid mdf, kv, and emissions files in setup.
c          (tcm, 4/6/92)
c
c     18.  move calculation of diagnostic deposition flux from
c          stepx and stepxf to calvdf and clvdff. (tcm, 4/6/92)
c
c     19.  fixed puffdmp to treat xloc and yloc as km instead of
c          grid units circa line 78 and to use yloc and xloc 
c          instead of yg and xg circa line 90.  (tcm, 4/6/92)
c
c     20.  fixed ttraj to use isrcmbn(n,nc) and nsrcmbn(n) instead
c          of isrcmbn(npuff,nc) and nsrcmbn(npuff) near line 138.
c          (tcm, 4/6/92)
c
c     21.  extended table of photolysis rates used by phot and
c          photf to include variations due to differing albedo,
c          haze, and ozone column.  gridded albedo, haze and
c          ozone column codes now read in by setup and update.
c          common photrk.cmd also changed.  (tcm, 4/7/92)
c
c    version 1.03 created from v 1.02 with following changes:
c
c     22.  moved interpolation of uf, vf, and fkv from main to 
c          update.  (tcm, 7/15/92)
c
c     23.  removed variables z0 and z0f from commons as they are not
c          used anymore.  (tcm, 7/15/92)
c
c     24.  added variable flandf, land use on fine grids.  added 
c          reads of flandf in setup.  moved depvelf from common
c          shrfin to com1f and dimensioned by number of fine grids.
c          added var tfsurf and interpolated it from tsurf.  added
c          routine srlyrf to calculate deposition on fine grids.
c          remove interpolation of depvelf from time step loop.
c          (tcm, 7/15/92)
c
c     25.  calculate ctlon and ctlat in setup for lat/lon case in
c          addition to cartesian case and use these vars instead
c          of calculating every time they are needed. (tcm, 7/15/92)
c
c    version 1.04 created from v 1.03 with following changes:
c
c     26.  fixed pass of depvelf from main to routines called by
c          main so that change 24 above works properly.
c          (tcm, 9/18/92)
c
c     27.  changed format of coarse grid restart file to match the
c          format of the initial conditions file but with file
c          name "instant".  added check of file name so that units
c          of concs will be changed from ppm to umoles/m3 if file
c          name of initial conditions file is not "instant".
c          (changes in routines setup, hedibc, restrt, printr)
c          (tcm, 9/18/92)
c
c     28.  removed depvelf from call to stepxf.  (tcm, 9/18/92)
c   
c     29.  moved set of concf and interpolation of ctlonf, ctlatf,
c          and avterf prior to first calls to deposition routines.
c          (tcm, 9/18/92)
c
c     30.  enforced minimum wind speed of 0.01 m/s in surlyr and 
c          srlyrf.  (tcm, 9/18/92)
c
c    version 1.05 created from v 1.04 with following changes:
c
c     31.  added code in terms, stepy, and stepyf to calculate change 
c          of layer depth for each coarse and fine grid timestep.  
c          (cae, 10/22/92)
c
c     33.  updated wetdep and wetdepf to calculate wet deposition for
c          no, no2, o3, co, pan, eth, and ald.  although code for so2
c          and so4 exist, wetdep must be modified for proper 
c          calculation of so4 and so2 wet deposition.  (cae, 10/22/92) 
c
c    version 1.10 created from v 1.05 with following changes:
c
c     35.  installed epa uam v 6.20 chemistry in place of uam-v
c          chemistry.  step4 and all routines below replaced plus
c          changes in aqbdat.f, ssday, ssdark, comchem, and chread.
c          (tcm, 12/14/92)
c
c     36.  tdrate altered to use look-up table.  added tirate to 
c          initialize table.  (mpl, 1/21/93)
c
c     37.  stepy and stepyf revised for improved efficiency in 
c          vertical advection.  (tcm, sbs, 2/3/93)
c
c     38.  made improvements to chem routines to make steady-state
c          solver more robust.  (mpl, 2/4/93)
c
c     39.  revised check of cell boundaries crossing in euler to 
c          check all boundaries instead of just outer (tcm, 2/18/93)
c
c     40.  fixed subscript in printout of mass flux in fmsprt.
c          (tcm, 2/19/93)
c
c     41.  completed installation of vectorized versions of calvdf
c          and clvdff.  (tcm, 2/25/93)
c
c     42.  revised printr, aaamain, and added prtint to print 
c          initial concentrations to restart files and to write
c          current time instead of 1 hour time span. (tcm, 3/4/93) 
c 
c     43.  added pufage to restart file (pgwrit and pgread).  added
c          declaration of mxage to pigpen.cmd.  properly set nskdmp
c          in puffdmp when age is exceeded.  (tcm, 3/8/93)
c
c     44.  changed setup so that fluxes and land use are properly
c          initialized when no agg file is used.  (tcm, 3/10/93)
c
c     45.  moved reads of fine grid land use to subroutin rdfsrf.
c          (tcm, 3/22/93)
c
c     46.  made correction to calculation of minbot in expand and 
c          expandf.  corrected calculation of delz in expandf.
c          (cae, 3/26/93)
c
c     47.  added check of lcart in setup when writing file headers
c          so that when lat/lon grid is being used, region definition
c          parameters are expressed in terms of lat/lon.  
c          (tcm, 4/14/93)
c
c     48.  corrected calculation of plume mass exiting coarse grid
c          region (pxflow) in ttraj to be in moles instead of 
c          micromoles.  (tcm, 4/14/93)
c    
c     49.  added code to update and setup to allow a file of 
c          deposition velocities to be read instead of doing internal
c          calculation.  (tcm, 5/4/93)
c
c     50.  split parm.cmd into two include files:  parm.cmd and
c          parchm.cmd.  parchm.cmd contains parameters for chemistry
c          and maximum species.  this allows object codes for chem
c          routines to be left alone when recompiling for change
c          of x, y, or z dimension.  (tcm, 5/4/93)
c
c     51.  added calculation of fluxes across fine grid boundaries
c          based on coarse grid variables.  (tcm, 5/6/93)
c                                                                     
c     52.  moved calculation of depth, vertical velocity, dilut and eta 
c          for the coarse grid to a separate subroutine so that these 
c          values are calculated every time step rather than at the
c          top of the hour.  (cae, 5/27/93)
c
c     55.  fixed subscript for rfacb to be last skin instead of npuff
c          at around line 86 in puffdmp (tcm, 6/16/93)
c
c     56.  change loop at around line 59 in fstep over j to go from 1 to
c          nfy instead of jyfb to jyfe (tcm, 8/31/93)
c
c     57.  in stepyf, for section calculating dilution for layer 1, at
c          around line 111, correct k to be 1.  (tcm, 8/31/93)
c
c     58.  eliminated array crad from rchem (tcm, 9/30/93)
c
c     59.  moved call to terms inside of stepx.  changed dimension oF
c          decay from x by y by species by level to x by species by 
c          level.  created new routine hgtnew to update heights.
c          (tcm, 9/30/93)
c
c     60.  fixed two if statements in each of expand and expandf to
c          branch only on true condition not in all cases.
c          (tcm, 1/19/94)
c
c    version 1.12 created from 1.11 with the following changes:
c
c     61.  revised plume expansion in PIG treatment to do initial 
c          expansion at release time and to eliminate F stability.
c          also added diagnostics.  (cae, tcm, 4/15/94)
c
c     62.  added code and new routine (ffgtrp) to interpolate fine 
c          grid wind and kv data from another fine grid instead of
c          coarse grid when needed. (tcm, 5/17/94)
c          
c     63.  added revision to chemistry to include additional radical-
c          radical reactions as implemented by gxy. (tcm, 5/17/94)
c 
c     64.  In subroutine update.f, extended check of layer thicknesses
c          (149 loop) to cover all layers instead of just layers 1
c          and 2.  (tcm, 7/15/94)
c
c     65.  Added common scratch.cmd to contain the scratch array from
c          which are allocated variable dimension data arrays.  This
c          common also contains the pointers to the beginning of each
c          array in scratch.  Also added subroutine alloc.f which
c          allocates space for an array from the scratch array.
c          Added some code in main routine to initialize variables
c          related to scratch usage.  (tcm, 7/15/94)
c
c     66.  Added code to calculate rolling o3 averages:  in setup.f,
c          check for species MXO3 in list of average species, add
c          species TMO3 and set lmxo3 flag, allocate space for
c          rolling average arrays from scratch array via calls to
c          alloc.  In common comd3.cmd, added minimum interval for
c          rolling o3 average (dtavg) and flag for rolling average
c          option (lmxo3).  Added code in averag and avergf to
c          optionally calculate rolling o3 average and keep track
c          of maximum hourly average o3.  Added the common block
c          avo3con.cmd to contain control variables used in
c          calculating rolling hourly ozone average and maximum
c          hourly average (the variable MXO3).  Modified calls 
c          to averag and avergf in main routine to be consistent
c          with new versions of these routines.  (tcm, 7/15/94)
c
c     67.  Cleaned up some if statements and print of simulation
c          options in setup.  (tcm, 7/15/94)
c
c     68.  In expand and expandf, imposed minimum value on wshr2 to
c          avoid floating pt exception.  CAE added a check for zero 
c          plume rise to avoid assigning an initial plume depth of
c          zero.  (tcm, 7/15/94)
c
c     69.  Added capability to read flowrat, and added calculation of 
c          hour-specific exit velocities if flowrat > 0 in getpt.
c          Added flowrat variable to common /stack/
c          CAE 7/6/94
c
c    version 1.13 created from 1.12 with the following changes:
c
c     70.  extended horizontal and vertical nesting capabilities to 
c          allow nested grids to be adjacent and to allow arbitrary 
c          subdivision of coarse grid layers.  changes in routines 
c          aaamain, bdrfil, fbdfil, crsfil, ffgtrp, fgrtrp, finfil, 
c          fstep, nstfil, rchemf, rvmmap, setup, and update.  added 
c          routines arrget, ckhgt, htfage, rdfzp, and reducr.  
c          changed common blocks com1f, ngmap, deffin, and shrfin.  
c          (tcm, 3/10/95)
c
c     71.  corrected interpolation type for surface temperature in 
c          aaamain.  (tcm, 3/10/95)
c
c     72.  set particulate bins in aqbdat and eliminate reads from 
c          setup.  (tcm, 3/10/95)
c
c     73.  set array dimensions in fgavwr and avergf to actual species 
c          dimension instead of a dummy.  (tcm, 3/10/95)
c
c     74.  skip unmodeled species in emissions totals in eftot.  
c          (tcm, 3/10/95)
c
c     75.  changed several routines to handle coordinates of point 
c          sources and fine grid spacing in lat/lon.  changes in 
c          emfine, grdsp, hedpts, puffdmp, and ttraj.  (tcm, 3/10/95)
c
c     76.  corrected subscript in check of plume reactivity flag in 
c          rpm and removed superfluous diagnostic on d(j) in smolar.  
c          (tcm, 3/10/95)
c
c    version 1.14 created from 1.13 with the following changes:
c
c     77.  Corrected calculation of heights in ffgtrp and fgrtrp
c          to handle vertical nesting.  (tcm, 6/95)
c                                                                     | 
c     78.  Modifications in beh084 to neutral momentum rise 
c          following similar changes to UAM PTSRCE preprocessor.  
c          Replaced mxz with nz in 2 statements.  (gem, 95/06/02)
c
c     79.  Added correction factor in stepy and stepyf to account
c          for tapering of lat/lon cells.  (tcm, 8/95)
c
c     80.  Replaced (dy**2) with (dy*dx(j)) in diffus and
c          diffsf. (gem,  95/08/21)
c
c     81.  Redefined checks in emcors and emfine of source grid 
c          location with respect to boundary cells (e.g., checking 
c          i.le.istr instead of i.lt.istr). (gem, 95/08/21)
c
c     82.  Corrected calculation of anti diffusion velocity
c          in smolar.  Affects south and west edges.
c          (tcm, 8/25/95)
c
c     83.  Added option to open P-i-G dump file to allow 
c          calculation of impact of undumped puffs on grid 
c          concentrations.  Changes in pgread, pgwrit, setup, 
c          and added routines pigdmp and dmppig and common
c          pigdmp.  (gem, 12/95)
c
c     84.  Fixed calculation of kdmp for parent grids in puffdmp.
c          (gem, 12/26/95)
c
c     85.  Added checks in ttraj of puff dimensions and dilution 
c          when new puffs are initialized to avoid problems with 
c          calm winds and/or excessive NOx concentrations in the 
c          puffs.  (gem, 96/02/20)
c
c     86.  Added check of minimum value in sigmay and sigmaz.
c          (gem, 3/96)
c    
c     87.  Changed nitr in ssday to initr to avoid conflict 
c          with float variable nitr.  (gem, 3/96)
c
c     88.  In fmsflo, changed nlayer to nzf for calculation of flux 
c          through top.  (gem, 3/14/96)
c
c     89.  In expand and expandf, modified checks on tgrad small 
c          for calculation of Ri.  Check now looks at absolute 
c          value of tgrad.  (gem, 96/03/27)
c
c     90.  Added loop 3111 in ttraj to reset idump for new puffs.
c          (gem, 96/03/27)
c
c     91.  Modified diagn and getpt to set default min/max for 
c          stack parameters.  (gem, 4/1/96)
c
c     92.  Modified formatted read of albedo codes in setup to 
c          allow larger grid size (gem, 4/1/96)
c
c     93.  Updated isoprene chemistry ala Carter.  Changes in 
c          chem routines, chread, setup, phot, photf, aqbdat and
c          in commons comchem, comchem2, and photrk.
c          (gzw, hpd, 8/1/96)
c                                                                     | 
c    version 1.15 created from 1.14 with the following changes:
c
c     94.  Got rid of message "cfrad in rchemf being set for" 
c          and any use of cfrad arrays
c          (tcm, 6/2/98)
c
c     95.  Got rid of message "tmpinc = 0.0" 
c          (tcm, 6/2/98)
c
c     96.  Got rid of messages about total number of puff chemistry 
c          calls and number of times NOx > 10 
c          (tcm, 6/2/98)
c
c     97.  In night chem routines check of a4c against bb2 was
c          changed to abs(a4c) .lt. Bb2 instead of a4c .lt. Bb2
c          (tcm, 6/2/98)
c
c     98.  Fixed so2 and so4 pointers in wetdep
c          (tcm, 6/2/98)
c
c     99.  Resolved discrepancies between chem2a and other chem 
c          routines.
c          (tcm, 6/2/98)
c
c     99.  Eliminated MXO3 max hourly average concentration in favor 
c          of high temporal resolution output
c          (tcm, 6/2/98)
c
c    100.  Changed to character declarations of variables used for 
c          characters (implemented to be portable to 
c          DEC, SGI, HP, etc.)
c          (tcm, 6/2/98)
c
c    101.  Implemented changes to aerodynamic resistance that were 
c          documented in memo to LADCO March 98
c          (tcm, 6/5/98)
c
c    102.  Fixed temperature dependence of peroxide reaction
c          (tcm, 6/5/98)
c
c    103.  Updated BCs hourly regardless of whether BC file is hourly
c          (tcm, 6/8/98)
c
c    104.  Set totime to tstr initially instead of 0 in order to 
c          make restart work more smoothly.
c          (tcm, 6/8/98)
c
c    105.  Implemented changes that make radical solution more stable
c          (tcm, 6/8/98)
c
c    106.  Revised date treatment to make dates more consistent on 
c          output.  Added treatment for years beyond 2000.  Require 
c          that calendar dates in 2000 and later use 4 digit year or 
c          year will be assumed to be Julian. Checked and
c          fixed leap year calculation.  Put in check so that model 
c          can cross over from one year to the next.	
c          (tcm, 11/3/98)
c                                                                     | 
c    version 1.16 created from 1.15 with the following changes:
c
c    107.  Added code in setup and update to read headers from met
c          files.
c          (tcm, 11/18/98)
c
c    108.  Added open of error log file at beginning of setup.
c          (tcm, 11/18/98)
c
c    109.  Redirected all error messages to error log, diag and
c          standard output.  Added unique error code to each message
c          written to the error log file.
c          (ara, 11/18/98)
c
c    110.  Eliminated references to receptors and receptor arrays.
c          (tcm, 11/18/98)
c
c    111.  Revised terrain file to provide latitude/longitude 
c          coordinates of each cell center and removed internal
c          calculation of cell locations (except when running in
c          latitude/longitude coordinates.  This allows use of 
c          an arbitrary cartesian coordinate system in km given
c          the availability of an appropriate preprocessor to 
c          transform the coordinates to/from lat/lon.
c          (tcm, 11/18/98)
c
c    112.  Added flag to control file to select fast or standard
c          chemistry solver.  Added fast solver chemistry routines.
c          (tcm, 4/8/99)
c                                                                     | 
c    version 1.30 created from 1.16 with the following changes:
c
c    113.  Added high resolution files for all fine grid data (that
c          is, temperature, humidity, cloud, rain).
c          (gem, 5/3/99)
c
c    114.  Upgraded to CB-IV-TOX chemical mechanism.  Species names
c          updated.  Photolysis rate i/o updated. Chem routines and
c          step4 routines replaced.
c          (dfg, 5/11/99)
c
c    115.  Added initialization of radical for fine grids for the
c          automatically generated chemistry solver.
c          (dfg, 05/11/99)
c          
c    116.  Added process analysis output.
c          (tcm, 7/7/99)
c
c    117.  Added NTR as product of reaction 55 and as product of
c          reaction 68 when NPHN is not simulated.
c          (tcm, 9/23/99)
c                                                                     | 
c    version 1.31 created from 1.30 with the following changes:
c
c    118.  Name of com3 include file changed to comd3 to avoid 
c          conflict with PC device name.
c          (tcm, 12/21/99)
c
c    119.  Formats and data statements using holleriths changed
c          to quoted strings to increase portability.
c          (tcm, 12/21/99)
c
c    120.  Changed limit on input line length for albedo data in
c          setup to allow 200 codes per line.
c          (tcm, 07/03/00)
c
c    121.  Imposed a minimum value check on ustar in pblmod to 
c          avoid unrealistic mixing rates.
c          (tcm, 07/03/00)
c
c    122.  Corrected dimension of cold in nstfil to use irrxyf.
c          (tcm, 07/03/00)
c
c    123.  Revised syntax in chem rate routines to enclose negative
c          coefficients in () to avoid compile problems. (Changes
c          in slowntb.f, slownta2.f, slownta1.f, slowdr.f, chem_std.f, 
c          chem2b_std.f, chem2a2_std.f, chem2a2_fst.f, chem2a1_std.f, 
c          and chem2a1_fst.f)
c          (tcm, 06/26/02)
c
c    124.  Eliminated dead code in irr_init1.f, emcors.f, and diagn.f
c          (tcm, 06/26/02)
c
c    125.  Added check of lnitr option before calculating con(knitr)
c          in step4_std.f
c          (tcm, 06/26/02)
c
c----------------------------------------------------------------------
c$Log: aaamain.f,v $
c  Revision 1.25  2002/06/26  20:44:13  tcm
c  Revised some syntax for improved portability
c
c  Revision 1.24  2000/07/03  22:38:12  tcm
c  Version 1.31 created from 1.30.
c
c  Revision 1.22  1999/09/25  00:19:04  tcm
c  Updated internal documentation for version 1.30.
c
c  Revision 1.21  1999/07/07  00:35:58  tcm
c  Added initialization and input and output calls for pa/irr treatment.
c
c  Revision 1.20  1999/05/12  16:30:20  gem
c  moved call to getpt before call to update in order
c  to have temporally varying stack temps available for
c  plume rise calcs\
c
c  Revision 1.19  1999/05/12  16:17:00  dfg
c  Added initialization of radical for fine grids for the automatically generated chemistry solver.
c
c  Revision 1.18  1999/05/05  20:31:06  gem
c  changed version number and date
c  removed some commented out code and cleaned up
c
c  Revision 1.17  1999/05/05  15:53:17  gem
c  fixed if-then-else for interpolation of depvel at model setup time
c
c  Revision 1.16  1999/05/03  18:27:49  gem
c  modified to allow input of fine grid data files for all met data
c  moved some fine grid interpolations to update routine
c
c Revision 1.1  1999/05/03  17:55:36  gem
c Initial revision
c
c  Revision 1.14  1998/11/20  18:39:43  tcm
c  corrected formats of messages on lines 1551 and 1817
c
c  Revision 1.13  1998/11/20  18:34:16  tcm
c  Updated to UAM-V version 1.16.
c
c  Revision 1.12  1998/11/16  16:07:58  ara
c  Made small modifications to format of error messages
c
c  Revision 1.11  1998/11/06  22:59:38  ara
c  Eliminated message error reference to unit 66 and changed it
c  for unit 8 (diag file)
c
c  Revision 1.10  1998/11/06  18:13:44  ara
c  Fixed format of error messages directed to ierrlg and diag files
c
c  Revision 1.9  1998/11/05  21:24:36  ara
c  Added errlog block group containing reference to log file (ierrlg)
c  Directed error message for lines 1504, 1740 and 1769 to diag file
c  Directed error message and assigned unique error code for lines 1504, 1740 nand 1769 to log file (ierrlg)
c
c  Revision 1.8  1998/11/04  01:03:29  tcm
c  Updated for version 1.15 including calendar dates past 1999
c
c  Revision 1.7  1997/06/03  17:11:55  tcm
c  added Carter 1 product isoprene chemistry update
c  (hpd, 8/1/96)
c
c  Revision 1.6  1995/04/26  00:34:51  tcm
c  	modified calls to interpolation routines to pass fine grid height
c   	array to allow for extended vertical nesting
c
c  	corrected interpolation type for surface temperature to be 21 instead of 11
c
c  	bdrfil called for all grids, bdrfil will determine those that must have BCs
c  	filled
c
c  	eliminated interpolation of holdf and hnewf which is now handled in update if
c  	necessary
c
c  	at each fine grid step, update heights for all fine grids in case heights are
c  	needed for vertical nesting
c
c  	fbdfil called for all fine grids regardless of nest level, fbdfil will fill
c  	bcs from appropriate grids
c
c  Revision 1.5  94/08/04  14:33:10  tcm
c  *** empty log message ***
c  
c  Revision 1.4  94/07/27  15:08:48  tcm
c  Initialized some variables used for allocating space from
c  scratch array.
c  Updated calls to averag and avergf to be consistent with new
c  versions of those routines.
c  
c  Revision 1.3  94/05/17  18:05:15  tcm
c  Revised plume expansion
c  Revised chem routines to include additional radical-radical reactions 
c  (ver 6.3 of chemistry)
c  Added routine ffgtrp to interpolate fine grid data from another fine grid
c  
c  Revision 1.2  94/02/10  20:39:53  tcm
c  Cosmetic revisions by gem, syw, tcm
c  
c----------------------------------------------------------------------
      include 'parfin.cmd'
      include 'parchm.cmd'
      include 'parm.cmd'
      include 'comuam.cmd'
      include 'aerosl.cmd'
      include 'ctlflg.cmd'
      include 'comd3.cmd'
      include 'deffin.cmd'
      include 'shrfin.cmd'
      include 'com1f.cmd'
      include 'efcon.cmd'
      include 'balanc.cmd'
      include 'iemcon.cmd'
      include 'stack.cmd'
      include 'pigpen.cmd'
      include 'pigdung.cmd'
      include 'pufloc.cmd'
      include 'rpm.cmd'
      include 'scratch.cmd'
      include 'errlog.cmd'  
      include 'adunit.cmd'
czswa-------------------------------------------------------------------
      include 'irmb.cmd'
czswz-------------------------------------------------------------------
      dimension tarray(2)
      logical endfl,datafl,prntfl, lrstrt
      integer aem
      character*132 fn
      character*24 versn
      dimension elapg(maxfin)
      logical lfdone
      logical lonhr
      data nmxpas /1000/
      data versn /'UAM-V v1.31, 06/26/02   '/
      data endfl,datafl,prntfl/3*.false./, mavg/2/
c
c
      write(*,3003) versn
 3003 format(' start model simulation ',a)
      nuchp=10
c
c open input files
c control file read on unit 7, all other files opened in setup. 
c
      write(*,3010)
 3010 format(' open input files')
      call getarg(1,fn)
      open(unit=7,file=fn,form='formatted',status='old')
      write(*,'(a,a)') 'opening control file ',fn
      if (iargc() .gt. 1) then
        call getarg(2,fn)
        read(fn,'(i10)') idebug
      else
        idebug = 0
      endif
      idiag = and(idebug,1)
      iflxdb = and(idebug,16384)
      tmpinc=0.
c
c  initialize the model
c
      write(*,3012) 
 3012 format(' initialize model')
c
c  initialize size of scratch array
c
      nscrtc = mxscrt
      nsclft = mxscrt
c
c  initialize all scratch pointers to 1
c
      ko3av = 1
      ko3tm = 1
      ko3pt = 1
      do 5 ifine=1,maxfin
        kcncf(ifine) = 1
        kcoldf(ifine) = 1
        kavcnf(ifine) = 1
        ko3avf(ifine) = 1
        ko3tmf(ifine) = 1
        ko3ptf(ifine) = 1
    5 continue
c
c  initialize coarse and fine grid deposition velocities to zero.
c
      do 45 l=1,mxspec
        do 35 j=1,mxy
          do 25 i=1,mxx
            depvel(i,j,l) = 0.
   25     continue
   35   continue
   45 continue
c
      do 57 ifine=1,maxfin
        do 55 l=1,mxspec
          do 53 ij=1,mxfxby
            depvelf(ij,l,ifine) = 0.
   53     continue
   55   continue
   57 continue
c
      call setup(time,ndate,tend,idaynf,totime,tdatnx,lrstrt,idebug)
c
      call flush(66)
      call flush(6)
      call flush(8)
c
czswa---------------------------------------------------------------------------
c  initialize the irr grid cells to output
c     the subdomain are controlled by the coarse grid cells
c     the user can either select the south-west/north-east corners to output
c     or specify the cells (x,y) explicitly
c
c     the dimension "iflag" is used to keep track of the cells to output
c
       call irr_init0
       call irr_init1(nox,noy,nlayer)
c
czswz---------------------------------------------------------------------------
c
c  set fine grid concentrations to coarse grid concs initially
c  and interpolate terrain heights onto fine grids.
c  also interpolate lat/lon of each cell.
c
      if (numfin .eq. 0) nmxpas = 0
      do 350 ifine=1,numfin
c
c   initilizing the radical for fine grids (dfg).
c
        do 881 iirad=1,mxrads
          do 881 jjrad=1,mxfx*mxfy*mxfz
          radconf(iirad,ifine,jjrad)=1.0e-7
 881    continue
c
        if(.not.lrstrt) then
          write(*,*)'lrstrt= ',lrstrt,' ... calling finfil'
          call finfil(cncf(1,1,1,ifine),nfx(ifine),nfy(ifine),
     &              nospec,nfz(ifine),ifine)
         endif
        inttyp = 21
        call fgrtrp(mxx,mxy,nox,noy,1,avterr,
     &              nfx(ifine),nfy(ifine),1,
     &              avterf(1,ifine),hnewf(1,1,ifine),
     &              ifine,inttyp,idebug)
        inttyp = 20
        call fgrtrp(mxx,mxy,nox,noy,1,ctlon,
     &              nfx(ifine),nfy(ifine),1,
     &              ctlonf(1,ifine),hnewf(1,1,ifine),
     &              ifine,inttyp,idebug)
        call fgrtrp(mxx,mxy,nox,noy,1,ctlat,
     &              nfx(ifine),nfy(ifine),1,
     &              ctlatf(1,ifine),hnewf(1,1,ifine),
     &              ifine,inttyp,idebug)
  350 continue
c
c
c  write initial concentrations to inst files
c
      call prtint(time,ndate)
c
      if (ldepn) then 
        call surlyr(time,ndate)
        if (idiag .ne. 0) then
          write(*,'(a)') ' finished surlyr'
        endif
        do 120 ifine=1,numfin
          if (ifsrf(ifine) .le. 0) then
c        
c        interpolate to get deposition velocities
c
            inttyp = 20
            call fgrtrp(mxx,mxy,nox,noy,nospec,depvel,
     &                  nfx(ifine),nfy(ifine),nospec,
     &                  depvelf(1,1,ifine),htf(1,1,ifine),
     &                  ifine,inttyp,idebug)
            if (idiag .ne. 0) then
              write(*,'(a,i3)')' finished fgrtrp depvelf for fg#',ifine
            endif
c
c        otherwise calculate from fine grid data
c
          else
c
c  calculate deposition velocities for fine grid
c
            call srlyrf(time,ndate,nfx(ifine),nfy(ifine), nospec, 
     &                ctlonf(1,ifine),ctlatf(1,ifine),
     &                cloudf(1,1,ifine),temprf(1,1,ifine),
     &                tfsurf(1,ifine), uf(1,1,ifine),vf(1,1,ifine),
     &                presf(1,1,ifine), htf(1,1,ifine),
     &                flandf(1,1,ifine), lstrsf, lsnowf, 
     &                ch2of(1,1,ifine), rainf(1,ifine),
     &                depvelf(1,1,ifine))
            if (idiag .ne. 0) then
              write(*,'(a,i3)') ' finished srlyrf for fg#',ifine
            endif
          endif
c
  120   continue
c
      endif
c
      call dtsize(time,ndate,deltat)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished dtsize'
      endif
c
      dummy=etime(tarray)
      cpu=tarray(1)
      cpu1=cpu
      write(*,3013) cpu
 3013 format(' model initialized cpusecs=',f10.1)
      call flush(66)
      call flush(6)
      call flush(8)
c
      call averag(1,deltat,time,ndate,xscrtc(ko3tm),xscrtc(ko3pt),
     &            xscrtc(ko3av))
c
      do 125 ifine=1,numfin
c
c      initialize fine grid average concentrations
c
        call avergf(1,nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  presf,temprf,
     &                  cncf(1,1,1,ifine),coldf(1,1,ifine),
     &                  avconf(1,1,ifine),avgtmf(ifine),
     &                  deltf(ifine),time,ndate,
     &                  xscrtc(ko3tmf(ifine)),xscrtc(ko3ptf(ifine)),
     &                  xscrtc(ko3avf(ifine)),ifine)
  125 continue
c
czswz--------------------------------------------------------------------
c  print the initial concentration
c
      call get_final(1,nfx(1),nfy(1),nfz(1),
     &                  nospec,cncf(1,1,1,1),1)
      do ifine=1,numfin
         call get_final(2,nfx(ifine),nfy(ifine),nfz(ifine),
     &                  nospec,cncf(1,1,1,ifine),ifine)
      enddo
      call irr_wrt(noxy,nlayer,nospec,nreact,time)
      call irr_wrtf(noxy,nlayer,nospec,nreact,time)
c  remove diagnostic print routines
c     call irr_wrt_asc(noxy,nlayer,nospec,nreact,time)
c     call irr_wrt_ascf(noxy,nlayer,nospec,nreact,time)
      call irr_init0
czswz--------------------------------------------------------------------
c
c  advance the model one time step in this loop. adjust deltat so that
c  the model hits print-times, data-update-times and end-time exactly.
c
      tprtnx=totime+dtprnt
   10 continue
      if (idiag .ne. 0) then
        write(*,'(a)') ' at top of time step loop'
      endif
c
      cpuold=cpu1
      dummy=etime(tarray)
      totnx=xtime(totime,deltat,1)
c
c  check the accumulated 24 hr time; should we print at the end of this
c  step?
c
      if(totnx.lt.tprtnx-1.e-9) go to 20
      dtold=deltat
c
c  adjust time step so we hit print-time exactly instead of over-
c  shooting it.
c
      deltat=xtime(tprtnx,totime,2)
      totnx=tprtnx
      prntfl=.true.
      mavg=3
c
c  if we want to read new data as well as print, set the dataflag
c
      if(abs(tdatnx-tprtnx).le.1.e-9) go to 30
c
c  check the accumulated 24 hr time; should we update the data at the
c  endof this step.  this section is skipped when tdatnx=tprtnx.
c
   20 if(totnx.lt.tdatnx-1.e-9) go to 40
c
c  adjust the time step so we hit data-update-time exactly without
c  over shooting it.
c
      deltat=xtime(tdatnx,totime,2)
      totnx=tdatnx
      prntfl=.false.
   30 datafl=.true.
   40 tnext=xtime(time,deltat,1)
      if(tnext.ge.2400.) then
        tnext=tnext-2400.
        call jtocal(ndate,ncdate)
        ncdate=ndayad(ncdate)
        call caltoj(ncdate,ndate)
      endif
c
c  check the time and date; should we complete the simulation at the
c  endof this time step?
c
      ndays = intrvl(ndate,idaynf)
      tchk1 = 2400.*ndays + tnext
      if (tchk1 .lt. tend-1.e-2) go to 60
      endfl=.true.
      datafl=.false.
      prntfl=.true.
      mavg=3
c
c  adjust time step so we hit the end of the simulation exactly.
c
      deltat=deltat-xtime(tchk1,tend,2)
      tnext=tend
      ndate=idaynf
      totnx=xtime(totime,deltat,1)
c
   60 continue
c
c   do mass budget calculations on even hours
c
      if (mod(int(time+.05),100) .eq. 0) then
        lonhr = .true.
      else
        lonhr = .false.
      endif
      if (lonhr) then
        call mascal
        do 65 ifine=1,numfin
          call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),delfx(1,ifine),
     &                delfy(ifine),cncf(1,1,1,ifine),htf(1,1,ifine),
     &                ifine)
          if (iflxdb .ne. 0) then
            call xmscal(mxx,mxy,mxz,mxspec,nox,noy,nlayer,
     &                  deltax,deltay,conc,h,ifine)
            call xmsprt(time,ndate,ifine)
          endif
          call fmsprt(time,ndate,ifine)
   65   continue
      endif
      call masflo(time,ndate,deltat,lonhr)
      call plgmas(deltat)

c   inject puff mass from pig submodel

      if (lpig) call inject(deltat)
c
c   model point source emissions
c
      call emcors(time,ndate,deltat,idebug)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished emcors'
        call mascal
        write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
      endif
c
      dummy=etime(tarray)
      cpu2=tarray(1)
c
c     calculate current layer heights from hold and hnew
c
      call hgtnew(deltat)
      if (idiag .ne. 0) then
        write(*,'(a)') ' Finished HGTNEW'
        call mascal
        write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
      endif
c
c     calculate coarse grid vertical velocity, dilution and entrainment 
c     rates
c
      call vertwd(time,ndate,idebug)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished vertwnd'
      endif
c
c     fill boundary concentrations for fine grids from 
c     coarse grid concentration array and do mass budget calculations
c
      do 70 ifine=1,numfin
        call bdrfil(ifine,nfx(ifine),nfy(ifine),nfz(ifine),
     &              htf(1,1,ifine))
        if (idiag .ne. 0) then
          write(*,'(a,i4)') ' finished bdrfil for grid ',ifine
        endif
        call xmsflo(mxx,mxy,mxz,mxspec,nox,noy,nlayer,deltax,deltay,
     &              conc,h,u,v,eta,deltat,ifine)
   70 continue
c
c  perform east-west integration
c
      dummy=etime(tarray)
      cpu3=tarray(1)
      call stepx(deltat,time,ndate)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished stepx'
        call mascal
        write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
      endif
c
c  perform north-south integration
c
      dummy=etime(tarray)
      cpu4=tarray(1)
      call stepy(deltat,idebug)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished stepy'
        call mascal
        write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
      endif
c
c perform vertical diffusion
c
      call calvdf(deltat)
      if (idiag .ne. 0) then
        write(*,'(a)') ' finished calvdf'
        call mascal
        write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
      endif
      dummy=etime(tarray)
      cpu5=tarray(1)
c
      call flush(6)        ! zsw
c
c***************************************************************
c*                                                             *
c        fine grid section.  will be bypassed if numfin is 0
c
      elapf1 = 0.
      elapf2 = 0.
      elapf3 = 0.
      elapf4 = 0.
      cpu520 = 0.
      cpu521 = 0.
      cpu522 = 0.
      cpu523 = 0.
      do 320 ifine=1,numfin
        elapg(ifine) = 0.
  320 continue
c
      if (numfin .gt. 0) then
        call fstep(deltat,idebug)
        if (idiag .ne. 0) then
          ifine = numfin
          write(*,'(a,/,a,/,4i4,2f10.2,f10.4,f10.4,i4)')
     &         ' Coming out of fstep: ifine,nfx,nfy,nfz,',
     &         ' delfx(1),delfy,deltat,deltf,ndtf', ifine, nfx(ifine),
     &         nfy(ifine), nfz(ifine), delfx(1,ifine), delfy(ifine),
     &         deltat, deltf(ifine), ndftot(ifine)
        endif
      endif
c
c   do several passes over fine grids
c
      do 450 ifpass=1,nmxpas
        ifpout = ifpass
c
c    set up which grids will be done on this pass and see if
c    all have by any chance been completed.
c
        lfdone = .true.
        do 355 ifine=1,numfin
c
c         if all steps are not done for this grid, then we
c         are not done with a coarse grid step.
c
          if (ndfcom(ifine) .lt. ndftot(ifine)) then
            lfdone = .false.
c
c           if this grid is inside another, don't let the outer
c           grid get ahead of this one by more than one step.
c
            if (ifgptr(ifine) .gt. 0) then
              if (ndfcom(ifgptr(ifine))*deltf(ifgptr(ifine))
     &          .gt. ndfcom(ifine)*deltf(ifine)+.00001) then
                ndfmax(ifgptr(ifine)) = 0
              else
c
c               unless the next grid out is done with a coarse
c               grid step, it can take another step.
c
                if (ndfcom(ifgptr(ifine)) .lt. ndftot(ifgptr(ifine)))
     &                ndfmax(ifgptr(ifine)) = 1
              endif
            endif
c
c         on the other hand, if all steps are done for this
c         grid, make sure no extra steps are taken
c 
          else
            ndfmax(ifine) = 0
          endif
  355   continue
        if (lfdone) go to 460
c
c        loop over all fine grids
c
        do 400 ifine=1,numfin
          if (ndfmax(ifine) .eq. 0) go to 400
c
c      interpolate data onto fine grid
c
c***gem  interpolation performed in update ************
c
          dummy=etime(tarray)
          cpu50=tarray(1)
c
          dummy=etime(tarray)
          cpu51=tarray(1)
          elapf1 = elapf1 + cpu51 - cpu50
c
c       calculate fkh (horizontal diffusivities on fine grid)
c
          call diffsf(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),uf(1,1,ifine),
     &                vf(1,1,ifine),fkh)
          dummy=etime(tarray)
          cpu52=tarray(1)
          elapf2 = elapf2 + cpu52 - cpu51 
c
c     loop over fine grid steps to complete one coarse grid step
c
          mfav = 2
          do 390 nfstep=1,ndfmax(ifine)
            ndfcom(ifine) = ndfcom(ifine) + 1
            timfg = time + (ndfcom(ifine)-1)*deltf(ifine)
c
c     update heights for all fine grids to current time
c
            deltht = elapsth - deltat + ndfcom(ifine)*deltf(ifine)
            do 370 if2 = 1,numfin
              call htfcal(nfx(if2),nfy(if2),nfz(if2),
     &                    holdf(1,1,if2),hnewf(1,1,if2),
     &                    htf(1,1,if2),deltht)
  370       continue
c
c     calculate dilution, vert wind
c
            call fvrtwd(nfx(ifine),nfy(ifine),nfz(ifine),
     &                uf(1,1,ifine),vf(1,1,ifine),
     &                hnewf(1,1,ifine),holdf(1,1,ifine),
     &                htf(1,1,ifine),delfx(1,ifine),
     &                delfy(ifine),etaf,tphioaf,dilutf,depthf,
     &                deltf(ifine),doldf)
c
            if (idiag .ne. 0) then
              write(*,'(a,i3)') ' finished fvrtwd, ifine = ', ifine
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif

c     inject puff mass from pig model into fine grid

            if (lpig) call injectf(nfx(ifine),nfy(ifine),nfz(ifine),
     &                   nospec,cncf(1,1,1,ifine),htf(1,1,ifine),
     &                   ifine)
c
c     add in point source and area emissions in fine grid
c
            call emfine(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  delfx(1,ifine),delfy(ifine),
     &                  qfarea(1,1,ifine),htf(1,1,ifine),
     &                  presf(1,1,ifine),temprf(1,1,ifine),
     &                  cncf(1,1,1,ifine),ifine,idebug)
c
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished emfine'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
c
c     do mass budget calculations
c
            call fmsflo(nfx(ifine),nfy(ifine),nfz(ifine),
     &                  delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                  htf(1,1,ifine),uf(1,1,ifine),vf(1,1,ifine),
     &                  etaf,bcf,deltf(ifine),ifine)
c
c  check if any fine grids within this one; fill in bc's if so
c
            call fbdfil(ifine,nfx(ifine),nfy(ifine),nfz(ifine),
     &                  nospec,htf(1,1,ifine),cncf(1,1,1,ifine))
c
c     linear chem (optional), wet deposition rates (optional)
c     (options examined in termsf, which fills array decayf)
c
            call termsf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,ifine,
     &              rainf(1,ifine),htf(1,1,ifine),temprf(1,1,ifine),
     &              ctlonf(1,ifine),ctlatf(1,ifine),decayf,
     &              depvelf(1,1,ifine),cncf(1,1,1,ifine),deltf(ifine),
     &              timfg,ndate) 
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished termsf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
c
c     x transport
c
            dummy=etime(tarray)
            cpuxx=tarray(1)
            call stepxf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  fkh,uf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                  htf(1,1,ifine),decayf,
     &                  cncf(1,1,1,ifine),
     &                  delfx(1,ifine),delfy(ifine),deltf(ifine),
     &                  ifine)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepxf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=etime(tarray)
            cpu520=cpu520+tarray(1)-cpuxx
            cpuxx = tarray(1)
c
c     z and y transport
c
            call stepyf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  fkh,vf(1,1,ifine),bcf(1,1,1,1,ifine),
     &                  dilutf,depthf,etaf,doldf,
     &                  cncf(1,1,1,ifine),delfx(1,ifine),
     &                  delfy(ifine),deltf(ifine),ifine)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished stepyf'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=etime(tarray)
            cpu521=cpu521+tarray(1)-cpuxx
            cpuxx=tarray(1)
c
c     vertical diffusion
c
            call clvdff(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  delfx(1,ifine), delfy(ifine),
     &                  cncf(1,1,1,ifine),fkv(1,1,ifine),htf(1,1,ifine),
     &                  depvelf(1,1,ifine),deltf(ifine),ifine)
            if (idiag .ne. 0) then
              write(*,'(a)') ' finished clvdff'
              call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),
     &                delfx(1,ifine),delfy(ifine),cncf(1,1,1,ifine),
     &                htf(1,1,ifine),ifine)
              write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &               (ftmas(l,ifine),l=1,nospec)
            endif
            dummy=etime(tarray)
            cpu522=cpu522+tarray(1)-cpuxx
            cpuxx=tarray(1)
c
c   do chemistry on fine grid 
c
            if (.not.linert) then
              call rchemf(nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  cncf(1,1,1,ifine),htf(1,1,ifine),
     &                  presf(1,1,ifine),temprf(1,1,ifine),
     &                  ch2of(1,1,ifine),cwatrf(1,1,ifine),
     &                  ahprcf(1,1,ifine),avterf(1,ifine),
     &                  ctlonf(1,ifine),ctlatf(1,ifine),
     &                  cloudf(1,1,ifine),
     &                  timfg,ndate,ifine,idebug)
              if (idiag .ne. 0) then
                write(*,'(a)') ' finished rchemf'
              endif
              dummy=etime(tarray)
              cpu523=cpu523+tarray(1)-cpuxx
              cpuxx=tarray(1)
            endif
c
c   accumulate concs for average
c
            if (mavg .eq. 3 .and. 
     &             ndfcom(ifine) .eq. ndftot(ifine)) mfav = 3
            call avergf(mfav,nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  presf(1,1,ifine),temprf(1,1,ifine),
     &                  cncf(1,1,1,ifine),coldf(1,1,ifine),
     &                  avconf(1,1,ifine),avgtmf(ifine),
     &                  deltf(ifine),time,ndate,
     &                  xscrtc(ko3tmf(ifine)),xscrtc(ko3ptf(ifine)),
     &                  xscrtc(ko3avf(ifine)),ifine)
c
  390     continue
          dummy=etime(tarray)
          cpu53=tarray(1)
          elapf3 = elapf3 + cpu53 - cpu52
          elapg(ifine) = elapg(ifine) + cpu53 - cpu50
  400   continue
c
c   refresh concs for fine grids with grids nested within them
c
        do 420 ifine=numfin,1,-1
          if (ifgptr(ifine) .gt. 0) then
            if2 = ifgptr(ifine)
            call nstfil(cncf(1,1,1,ifine),cncf(1,1,1,if2),
     &                  htf(1,1,ifine),htf(1,1,if2),nfx(ifine),
     &                  nfy(ifine),nfz(ifine),nfx(if2),nfy(if2),
     &                  nfz(if2),nospec,ifine,if2)
          endif
  420   continue
c
  450 continue
c
c    ran out of passes before completing fine grid calcs
c
      if (numfin .gt. 0) then
        write(*,*) ' Maximum number of fine grid passes (',
     &             nmxpas, ') has been exceeded.'
        write(*,*) ' Increase nmxpas'
        write(8,*) ' Maximum number of fine grid passes (',nmxpas,
     &             ') has been exceeded.'
        write(8,*) ' Increase nmxpas'
        write (ierrlg,'(i4,1x,a,a,a,a,a)') 1042, ' Maximum number of', 
     &             ' fine grid passes (',nmxpas,') has been',
     &            ' exceeded.Increase nmxpas'


        stop
      endif
c
c    fill in coarse grid with fine grid concs where they overlap
c
  460 dummy = etime(tarray)
      cpu53 = tarray(1)
      do 470 ifine=1,numfin
        if (ifgptr(ifine) .eq. 0) then
c
c  temporary diagnostic
c
          if (idiag .ne. 0) then
            val=conc(44,16,3,1)*1000.0
            write(*,*) ' before crsfil conc(44,16,3,1) is ',val
            val=conc(44,16,17,1)*1000.0
            write(*,*) ' before crsfil conc(44,16,17,1) is ',val
          endif
c
          call crsfil(cncf(1,1,1,ifine),htf(1,1,ifine),nfx(ifine),
     &                nfy(ifine),nospec,nfz(ifine),ifine,idebug)
          if (idiag .ne. 0) then
            write(*,'(a)') ' finished crsfil'
          endif
c
c  temporary diagnostic
c
          if (idiag .ne. 0) then
            val=conc(44,16,3,1)*1000.0
            write(*,*) ' after crsfil conc(44,16,3,1) is ',val
            val=conc(44,16,17,1)*1000.0
            write(*,*) ' after crsfil conc(44,16,17,1) is ',val
          endif
c
        endif
  470 continue
c
      if (numfin .gt. 0) then
        ifpout = ifpout - 1
        write(*,*) ' completed fine grids in ',ifpout,' passes.'
        dummy=etime(tarray)
        cpu54=tarray(1)
        elapf4=cpu54-cpu53
        write(*,3302) elapf1,elapf2,elapf3,elapf4,cpu520,cpu521,cpu522,
     &                  cpu523
        write(66,3302) elapf1,elapf2,elapf3,elapf4,cpu520,cpu521,cpu522,
     &                   cpu523
 3302   format(' elapsed time for fine grid operations:  ',/,
     &         '   Interpolation: ',f7.2,5x,' diffsf,etc:  ',f7.2,/,
     &         '   Transport loop: ',f7.2, ' crsfil: ',f7.2,/,
     &         '   stepxf:  ',f7.2,'  stepyf:  ',f7.2,'  clvdff:  ',
     &         f7.2,/,'   rchemf: ',f7.2)
        write(*,3303) (ifine,elapg(ifine),ifine=1,numfin)
        write(66,3303) (ifine,elapg(ifine),ifine=1,numfin)
 3303   format(' total elapsed for each nested grid:',/,
     &         (5x,i4,5x,f7.2))
      endif
c
c
c     if running oxidant version (lchem=.true.) then do chemistry
c
c
c     if running in inert mode (no chemistry, linert=.true) bypass
c     rchem
c
      call flush(66)
      call flush(8)
      dummy=etime(tarray)
      cpu5xt=tarray(1)
c
      if(.not.linert) then
        call rchem(deltat,time,ndate,idebug)
        if (idiag .ne. 0) then
          write(*,'(a)') ' finished rchem'
          call mascal
          write(*,'(a,(1x,1pe10.3,5e10.3))') ' tot mass by spec:',
     &      (tmas(l),l=1,nospec)
        endif
      endif
c
      dummy=etime(tarray)
      cpu6=tarray(1)
c
c  call plume-in-grid (pig) submodel
c
      if (lpig) call ttraj(deltat,time,ndate,idebug)
      dummy = etime(tarray)
      cpu60 = tarray(1)
c
c  compute time average concentrations
c
      time=tnext
      totime=totnx
      write(66,80) time,totime,deltat
   80 format(/10x,'time',f8.2,10x,'totime',f8.2,10x,'deltat',f8.2)
      call averag(mavg,deltat,time,ndate,xscrtc(ko3tm),xscrtc(ko3pt),
     &            xscrtc(ko3av))
      dummy = etime(tarray)
      cpu61 = tarray(1)
c
czswa------------------------------------------------------------------
c  time to output final concentration for this time step
c
      do ifine=1,numfin
         call get_final(2,nfx(ifine),nfy(ifine),nfz(ifine),
     &                  nospec,cncf(1,1,1,ifine),ifine)
      enddo
c
czswz------------------------------------------------------------------
c
c     calculate new exposure class and stability
c
c     note: if datafl=.true. then this is done in update
c
c
c  update the data if necessary
c
      if (datafl) then
c
c  read in temporally varying point source emissions
c
        kntpnt=0
  290   continue
        if (lpts) then
          call getpt(time,ndate,edf,nemit,iqeof)
          if (iqeof .gt. 0) then
            kntpnt = kntpnt + 1
            if (kntpnt .gt. 2) then
              write(*,'(a)') ' cannot synch ptsource file'
              write(8,'(a)') ' cannot synch ptsource file' 
              write (ierrlg,'(i4,1x,a,a)') 1043,
     &	      ' cannot synch ptsource file'
              stop
            endif
            rewind edf
            call hedpts(nospec, nox, noy, edf, nemit, kemit)
            go to 290
          endif
        endif
c
        call update(time,ndate,tdatnx,totime,idebug)
        if(lchmag)call rvmmap(nox,noy,nlayer,8,time,ndate,idebug)
        if (ldepn) then
          call surlyr(time,ndate)
          if (idiag .ne. 0) then
            write(*,'(a)') ' finished surlyr'
          endif
          do 180 ifine=1,numfin
            if (ifsrf(ifine) .le. 0) then
c        
c        interpolate to get deposition velocities
c
              inttyp = 20
              call fgrtrp(mxx,mxy,nox,noy,nospec,depvel,
     &                    nfx(ifine),nfy(ifine),nospec,
     &                    depvelf(1,1,ifine),htf(1,1,ifine),
     &                    ifine,inttyp,idebug)
              if (idiag .ne. 0) then
                write(*,'(a,i3)')
     &               ' Finished fgrtrp depvelf for fg#',ifine
              endif
c
c        otherwise calculate from fine grid data
c
            else
c        
c  calculate deposition velocities for fine grid
c
            call srlyrf(time,ndate,nfx(ifine),nfy(ifine), nospec, 
     &                ctlonf(1,ifine),ctlatf(1,ifine),
     &                cloudf(1,1,ifine),temprf(1,1,ifine),
     &                tfsurf(1,ifine), uf(1,1,ifine),vf(1,1,ifine),
     &                presf(1,1,ifine), htf(1,1,ifine),
     &                flandf(1,1,ifine), lstrsf, lsnowf, 
     &                ch2of(1,1,ifine), rainf(1,ifine),
     &                depvelf(1,1,ifine))
              if (idiag .ne. 0) then
                write(*,'(a,i3)') ' Finished srlyrf for fg#',ifine
              endif
            endif
c
  180     continue
        endif
c
        datafl=.false.
c
      else
        if(prntfl) deltat =dtold
      endif
c
      call dtsize(time,ndate,deltat)
c
      dummy = etime(tarray)
      cpu62 = tarray(1)
c
czswa------------------------------------------------------------------
c  time to output final concentration for this time step
c
      call get_final(1,nfx(1),nfy(1),nfz(1),
     &                  nospec,cncf(1,1,1,1),1)
c
czswz------------------------------------------------------------------
c
c  print if necessary
c
      if (endfl) go to 91
c
      if (larea) then
        kntaem = 0
        call gunit(aem,time,ndate)
        do 1901 ifine=1,numfin
          if (aem .eq. aem1) then 
            ifaem(ifine) = ifaem1(ifine)
          else if (aem .eq. aem2) then
            ifaem(ifine) = ifaem2(ifine)
          else if (aem .eq. aem3) then
            ifaem(ifine) = ifaem3(ifine)
          endif
 1901   continue
c
  190   continue
        call getqar(mxx,mxy,mxspec,nox,noy,naemit,aem,time,ndate,
     &              emtim1,iemdy1,emtim2,iemdy2,qarea,iqeof)
        if (iqeof .ne. 0) go to 195
        do 1902 ifine=1,numfin
          if (ifaem(ifine) .gt. 0) then
            call getqar(nfx(ifine),nfy(ifine),nfemit(ifine),
     &                  nfx(ifine),nfy(ifine),nfemit(ifine),
     &                  ifaem(ifine),time,ndate,
     &                  emtm1f(ifine),iemd1f(ifine),emtm2f(ifine),
     &                  iemd2f(ifine),qfarea(1,1,ifine),iqeof)
            if (iqeof .ne. 0) go to 195
          endif
 1902   continue
        go to 199
c
  195   continue
        kntaem = kntaem + 1
        if (kntaem .gt. 2) then
         write(*,'(a)') ' cannot synch emissions file'
         write (8,'(a)') ' cannot synch emissions file' 
         write (ierrlg,'(i4,1x,a,a)') 1044, ' cannot synch emissions',
     &                                   ' file'
          stop
        endif
        rewind aem
        call hedqar(nospec,nox,noy,aem,naemit,kaemit)
        do 1951 ifine=1,numfin
          if (ifaem(ifine) .gt. 0) then
            rewind ifaem(ifine)
            call hedqar(nospec,nfx(ifine),nfy(ifine),ifaem(ifine),
     &                  nfemit(ifine), kfemit(1,ifine))
          endif
 1951   continue
        go to 190
      endif
c
  199 continue
c
c     total up point and area sources
c
      if(.not.prntfl) go to 100
      do 93 ll=1,naemit
        l=kaemit(ll)
        if (l .gt. 0) then
          tarea(l,1)=0.0
          do 95 j=1,noy
            do 94 i=1,nox
              tarea(l,1)=tarea(l,1)+qarea(i,j,ll)
   94       continue
   95     continue
        endif
   93 continue
      do 96 ll=1,nemit
        l=kemit(ll)
        if (l .gt. 0) then
          tarea(l,2)=0.0
          do 92 i=1,nopts
            tarea(l,2)=tarea(l,2)+ptemis(ll,i)
   92     continue
        endif
   96 continue
      write(8,3900) (tarea(i,1),i=1,mxspec)
      write(8,3901) (tarea(i,2),i=1,mxspec)
 3900 format(' tarea= ',11(1pe12.4),/,8x,11(1pe12.4))
 3901 format(' tpont= ',11(1pe12.4),/,8x,11(1pe12.4))
 3300 format(' read area source data ',i10,f10.1,i10,i10)
c
c  total area source emissions on fine grids
c
      do 98 ifine=1,numfin
        call eftot(nfx(ifine),nfy(ifine),nospec,
     &                  qfarea(1,1,ifine),ifine,idebug)
   98 continue
c
   91 prntfl=.false.
      mavg=2
      call printr(time,ndate)
      if (lpig) call pgwrit(time,ndate)
      tprtnx=totime+dtprnt
      if(mod(tprtnx,100.0) .gt. 59.9)then
        tprtnx=tprtnx-60.0+100.0
      endif
c
c  reinitialize the averaging process for the next print interval
c
      call averag(1,deltat,time,ndate,xscrtc(ko3tm),xscrtc(ko3pt),
     &            xscrtc(ko3av))
c
      do 105 ifine=1,numfin
c
c      reinitialize fine grid average concs
c
        call avergf(1,nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                  presf(1,1,ifine),temprf(1,1,ifine),
     &                  cncf(1,1,1,ifine),coldf(1,1,ifine),
     &                  avconf(1,1,ifine),avgtmf(ifine),
     &                  deltf(ifine),time,ndate,
     &                  xscrtc(ko3tmf(ifine)),xscrtc(ko3ptf(ifine)),
     &                  xscrtc(ko3avf(ifine)),ifine)
  105 continue
c
czswa-------------------------------------------------------------------------
c  output the results
c
      if (lhrout) then
         call irr_wrt(noxy,nlayer,nospec,nreact,time)
         call irr_wrtf(noxy,nlayer,nospec,nreact,time)
c      remove diagnostic print routines
c        call irr_wrt_asc(noxy,nlayer,nospec,nreact,time)
c        call irr_wrt_ascf(noxy,nlayer,nospec,nreact,time)
         call irr_init0
      endif
c
czswz-------------------------------------------------------------------------
c
c  bye-bye?
c
  100 continue
      dummy=etime(tarray)
      cpu7=tarray(1)
      elapt=cpu7-cpuold
      elap1=cpu2-cpu1
      elap2=cpu3-cpu2
      elap3=cpu4-cpu3
      elap4=cpu5-cpu4
      elap5=cpu6-cpu5xt
      elap60=cpu60-cpu6
      elap61=cpu61-cpu60
      elap62=cpu62-cpu61
      elap6=cpu7-cpu62
      write(*,3301) time,ndate,deltat,cpu7,elapt,elap1,elap2,elap3
     &,elap4,elap5,elap60,elap61,elap62,elap6
      write(66,3301) time,ndate,deltat,cpu7,elapt,elap1,elap2,elap3
     &,elap4,elap5,elap60,elap61,elap62,elap6
 3301 format(' End dt ',f7.1,i7.5,f7.2,f15.1,' elapt=',f7.2,/
     &,'emcors',f7.2,' hgtnew=',f7.2,' stepx=',f7.2,' stepy=',f7.2
     &,' chem=',f7.2,/,' ttraj=',f7.2,' averag=',f7.2
     &,' update/surlyr=',f7.2,
     & ' Other=',f7.2)
      cpu1=cpu7
      call flush(0)
      call flush(66)
      call flush(8)
c
czswa-------------------------------------------------------------------------
c  decide whether to output at every time-step (careful about file size ...)
c  or at the end of each hour (much more reasonable sized)
c
      if (.not.lhrout) then
         call irr_wrt(noxy,nlayer,nospec,nreact,time)
         call irr_wrtf(noxy,nlayer,nospec,nreact,time)
c      remove diagnostic print routines
c        call irr_wrt_asc(noxy,nlayer,nospec,nreact,time)
c        call irr_wrt_ascf(noxy,nlayer,nospec,nreact,time)
         call irr_init0
      endif
c
czswz-------------------------------------------------------------------------
c
c  advance the model one time step in this loop.
      if(.not.endfl) go to 10
c
c...if endfl is true print last hour and cumulative mass fluxes
c   ---rrs,tcm 6/91
c
      lonhr = .true.
      call mascal
      do 73 ifine=1,numfin
        call fmscal(nfx(ifine),nfy(ifine),nfz(ifine),delfx(1,ifine),
     &                delfy(ifine),cncf(1,1,1,ifine),htf(1,1,ifine),
     &                ifine)
        if (iflxdb .ne. 0) then
          call xmscal(mxx,mxy,mxz,mxspec,nox,noy,nlayer,
     &                deltax,deltay,conc,h,ifine)
          call xmsprt(time,ndate,ifine)
        endif
        call fmsprt(time,ndate,ifine)
   73 continue
      call plgmas(deltat)
      call masflo(time,ndate,deltat,lonhr)
c
      do 75 ifine = 1, numfin
        if (iflxdb .ne. 0) then
          call xmscal(mxx,mxy,mxz,mxspec,nox,noy,nlayer,
     &                  deltax,deltay,conc,h,ifine)
          call xcmprt(time,ndate,ifine)   
        endif
        call fcmprt(time,ndate,ifine)   
  75  continue
      call cumprt(time,ndate)   
c
      stop
      end
