      subroutine chkdat(idate,errflg)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c
c$Log: chkdat.f,v $
c  Revision 1.3  1998/11/04  01:34:37  tcm
c  checks revised to allow calendar dates past 1999 and to
c  default Julian date range from 1951 to 2050
c
c  Revision 1.2  94/02/10  20:53:53  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c     routine checks calender and Julian dates for proper format
c
      logical errflg
c
      if(idate.gt.99999) go to 99
c
      iyear=idate/1000
      if (mod(iyear,4) .eq. 0) then
        iylen = 366
      else
        iylen = 365
      endif
      if((iyear.gt.99)) go to 99
      iday = mod(idate,1000)
      if((iday.lt.1).or.(iday.gt.iylen)) go to 99
c
      return
c
   99 write(8,101) idate
  101 format(5x,'input date = ',i10,/,'Date should be a 5 ',
     &   'digit Julian date: yyddd',/
     &   'e.g. November 18, 1980 = 80323',/,
     &   '  or January 1, 2000 = 00001')
      errflg=.true.
      return
      end
