      subroutine cnvtbc
c
c     *** (c) Copr. 1998  Systems Applications, Inc.  San Rafael, CA
c
c$Log: cnvtbc.f,v $
c Revision 1.1  1998/11/04  01:35:34  tcm
c Initial revision
c
c  
c  Derived from getbc, 6/8/98, tcm
c
c
c
c  convert boundary concentrations in ppm to micromoles/m3
c  (tcm, 6/8/98)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'ibccon.cmd'
      include 'comchem.cmd'
      include 'ppmcon.cmd'
c
c
c  set all concentrations to numerical lower bound
c
      do 30 k=1,nlayer
        do 28 l=1,nospec
          do 26 j=1,mxxx
            do 24 i=1,4
              bc(j,i,l,k) = bdmol(l)
   24       continue
   26     continue
   28   continue
   30 continue
c
c
      do 200 l=1,nbcsp
        lint = kbcsp(l)
        do 190 nn=1,4
          ncel = noy
          if (nn .gt. 2) ncel = nox
          nbc = 5 - nn
          if (lint .eq. 0) go to 190
          do 150 j=1,ncel
            if (nbc .eq. 1) then
              ixx = j
              jyy = jend(j)
            else if (nbc .eq. 2) then
              ixx = j
              jyy = jstr(j)
            else if (nbc .eq. 3) then
              ixx = iend(j)
              jyy = j
            else if (nbc .eq. 4) then
              ixx = istr(j)
              jyy = j
            endif
            do 140 k=1,nlayer
              if (ixx .ge. 1 .and. ixx .le. nox .and.
     &            jyy .ge. 1 .and. jyy .le. noy .and.
     &            bcppm(j,nbc,lint,k) .ge. 0.) then
                bc(j,nbc,lint,k) = bcppm(j,nbc,lint,k)
     &                             *press(ixx,jyy,k)*273.
     &                             /(temper(ixx,jyy,k)*cpfac)
              else
                bc(j,nbc,lint,k) = -9.
              endif
  140       continue
  150     continue
  190   continue
  200 continue
c
      return
c
      end
