      subroutine fmscal(nxf,nyf,nzf,delfx,delfy,cncf,htf,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: fmscal.f,v $
c  Revision 1.2  1994/02/10  20:56:08  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c     routine calculates mass budget for a fine grid
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
      dimension cncf(nxf,nyf,nospec,nzf), htf(nxf,nyf,nzf)
      dimension delfx(nyf)
c-----------------------
c     Quick mass budget calculation
c     (note: FAC has a factor of 1.E3 to account for
c     conversion of micromoles to moles (1.E-6) and 
c     for conversion of cu. km to cu m (1.E9)
c-----------------------
      do 5535 l=1,nospec
        ftmas(l,ifine) = 0.
        do 5534 k=1,nzf
          do 5533 j=2,nyf-1
            do 5532 i=2,nxf-1
              if (k .eq. 1) then
                hdel = htf(i,j,1)
              else
                hdel = htf(i,j,k) - htf(i,j,k-1)
              endif
              fac = delfx(j)*delfy*hdel*1.e3
              ftmas(l,ifine) = ftmas(l,ifine)+cncf(i,j,l,k)*fac
 5532       continue
 5533     continue
 5534   continue
 5535 continue
      return
      end
