      subroutine get_difc (id,iba,icf)
c
c  the purpose of this subroutine is to get the difference
c  in concentration before and after the process
c
c$Log: get_difc.f,v $
c  Revision 1.1  1999/07/07  00:47:49  tcm
c  Initial revision
c
c
c  for those of you who are actually reading the code,
c     id:
c         1 - pig, coarse grid
c         2 - point sources, coarse grid
c         3 - area sources, coarse grid
c         4 - chemistry, coarse grid
c         5 - fill-ins, filling fine conc into coarse grid cell
c     iba:
c         1 - before the call
c         2 - after the call
c     icf:
c         1 - coarse
c         2 - fine
c
c
      include 'parm.cmd'
      include 'parfin.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'irmb.cmd'
c
c  differentiate between coarse and fine
c
      irrstrt = 1
      if (icf.eq.1) irrend = irr_coarse
      if (icf.eq.2) irrend = irr_fine
c
      if (iba.eq.1) then
         do 50 i = irrstrt,irrend
         do 50 l = 1,nospec
         do 50 k = 1,nlayer
            cmem(i,l,k) = 0.0
50      continue
c
         do 110 i = irrstrt,irrend
         do 110 l = 1,nospec
         do 110 k = 1,nlayer
            cmem(i,l,k) = conc(irr_x(i),irr_y(i),l,k)
110      continue
c
      elseif (iba.eq.2) then
c
         do 210 i = irrstrt,irrend
         do 210 l = 1,nospec
         do 210 k = 1,nlayer
            cmem(i,l,k) = conc(irr_x(i),irr_y(i),l,k)-cmem(i,l,k)
210      continue
c
c  call irr_conc to accumulate the concentration
c
         call irr_conc(id,irrstrt,irrend,nlayer,nospec)
c
      endif
c
      return
      end

