c  IRMB.CMD
c
c  Common block for Integrated Process Rate Analysis Method
c
c$Log: irmb.cmd,v $
c  Revision 1.2  1999/09/25  00:21:03  tcm
c  Reset irrrs parameter to be same as mxgrx.
c
c  Revision 1.1  1999/07/07  00:38:37  tcm
c  Common blocks for pa/irr
c
c
c   (increased dimension on fine grid arrays to mxfz, tcm, 7/2/96)
c
       PARAMETER (irrxy=230, irrxyf=1600, irrrs=mxgrx)
C
       LOGICAL IRR, LHROUT
C
       COMMON /IRR1/ IRR, IRROUT, IRRDT, BT, LHROUT,
     &               irrcrs, irrfine, irrin,
     &               irr_grds,IRR_LAYER,
     &               irr_coarse,irr_fine,
     &               irr_ipv(mxfz), iflag(mxx,mxy),
     &               irr_x(irrxy), irr_y(irrxy),
     &               irr_f(irrxy), irr_ff(irrxyf),
     &               irr_xf(irrxyf), irr_yf(irrxyf),
     &               iflagf(mxfx,mxfy,maxfin),
     &               irr_ipvf(maxfin,mxfz),irr_layerf(maxfin),
     &               imspec(10,mxspec)
       character*4 imspec
c
       COMMON /IRR2/ final(irrxy,mxspec,mxz),
     &               fillin(irrxy,mxspec,mxz),
     &               cchem(irrxy,mxspec,mxz),
     &               aemis(irrxy,mxspec,1),
     &               pemis(irrxy,mxspec,mxz),
     &               pig(irrxy,mxspec,mxz),
     &               clorz(irrxy,mxspec,mxz),
     &               cmem(irrxy,mxspec,mxz),
     &               r_tot (irrxy,irrrs,mxz),
     &               ewflux(2,irrxy,mxspec,mxz),    ! fluxes on E-W boundaries
     &               snflux(2,irrxy,mxspec,mxz),    ! fluxes on S-N boundaries
     &               btflux(2,irrxy,mxspec,mxz)     ! fluxes on B-T boundaries
c     &               rate_rk(irrxy,IRRRS,mxz),    ! photolysis rate, not used
C
       COMMON /IRR3/ finalf(irrxyf,mxspec,mxfz),
     &               fillinf(irrxyf,mxspec,mxfz),
     &               cchemf(irrxyf,mxspec,mxfz),
     &               aemisf(irrxyf,mxspec,1),
     &               pemisf(irrxyf,mxspec,mxfz),
     &               pigf(irrxyf,mxspec,mxfz),
     &               clorzf(irrxyf,mxspec,mxfz),
     &               cmemf(irrxyf,mxspec,mxfz),
     &               r_totf (irrxyf,irrrs,mxfz),
     &               ewfluxf(2,irrxyf,mxspec,mxfz),  ! fluxes on E-W boundaries
     &               snfluxf(2,irrxyf,mxspec,mxfz),  ! fluxes on S-N boundaries
     &               btfluxf(2,irrxyf,mxspec,mxfz)   ! fluxes on B-T boundaries
c     &               rate_rkf(irrxyf,IRRRS,mxfz),   ! photolysis rate, not used
c
