      subroutine prtint(time,ndate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: prtint.f,v $
c  Revision 1.3  1999/12/21  19:28:20  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.2  1994/02/10  20:59:12  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c  print initial concentrations to inst file - tcm, 3/4/93 
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'com1f.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
c
c
c
c
      tmu2 = time/100.
      tmui2 = tmu2 + .001
      tmui1 = tmu2 - .001
      ndu2 = ndate
      idum = 1
c
c     write out dump files
c
      write(51) ndu2, tmui1, ndu2, tmui2
      do 4 k=1,nospc1
        do 3 l=1,nlayer
          write(51) idum, (mspec(i,k),i=1,10),
     &              ((conc(i,j,k,l),i=1,nox),j=1,noy)
    3   continue
    4 continue
c
c  write out fine grid inst concs
c
      if (ifinst .gt. 0) write(ifinst) time, ndate
      do 5 ifine=1,numfin
        if (ifinst .gt. 0) then
          call fgwrit(ifinst,nfx(ifine),nfy(ifine),nfz(ifine),nospec,
     &                cncf(1,1,1,ifine))
        endif
    5 continue
c
c  ---flush causes buffer to be flushed so that data is safely
c     written to disk
c
      call flush(51)
      if (ifinst .gt. 0) call flush(ifinst)
c
      return
      end
