c
c$Log: shrfin.cmd,v $
c  Revision 1.5  1999/05/03  18:42:58  gem
c  added additional fine grid arrays
c
c  Revision 1.3  1995/04/26  00:47:44  tcm
c  	moved hnewf and holdf from shrfin to com1f
c
c  Revision 1.2  94/02/10  21:05:29  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c 
c  common /shrfin/ contains arrays shared by the fine grids
c  defined in the region.  data is interpolated onto the
c  fine grid from the coarse grid.  when the program moves
c  from one fine grid to the next, data for the previous fine
c  grid will be overwritten.  shared arrays are defined as
c  follows:
c
c      fkh - exchange coefficient
c      wf - vertical component of wind
c      etaf - effective vertical wind
c      dilutf - vertical dilution term
c      depthf - depth of layers
c      decayf - wet deposition, linear chem rates
c
      common /shrfin/ fkh(mxfxby,mxfz), wf(mxfxby,mxfz),
     &                etaf(mxfxby,mxfz),
     &                dilutf(mxfxby,mxfz), depthf(mxfxby,mxfz),
     &                doldf(mxfxby,mxfz),
     &                decayf(mxfxby,mxspec,mxfz),
     &                lstrsf(mxfxby), lsnowf(mxfxby)
c
