      subroutine stoke(d,vsed,ustar,st)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: stoke.f,v $
c  Revision 1.3  1998/11/04  02:02:28  tcm
c  Eliminated superfluous calculation of re.
c
c  Revision 1.2  94/02/10  21:01:30  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c**********************************************************************
c
c-----this routine estimates the stokes number
c-----the input parameters are
c----- d = diameter of the particle in m
c----- vsed = stokes sedimentation velocity (m/s)
c----- ustar = friction velocity (m/s)
c----- the output is
c----- st = stokes number for the appropriate surface
c
c**********************************************************************
c
      data a1,a2,a3,xmean,visc/1.257,0.40,0.55,6.53e-08,1.5e-05/
      data bk,xmu,vk/1.38e-16,1.83e-02,0.4/
      data rhoair,grav/1000.,9.81/
      cc = 1.+(2*xmean/d)*(a1 + a2*exp(-a3*d/xmean))
      st = vsed*ustar**2/(grav*cc*visc)
c     re = ustar*zo/visc
      return
      end
