c
c  common /deffin/ defines the number of fine grids and 
c  attributes of each.  the attributes are:
c
c$Log: deffin.cmd,v $
c  Revision 1.6  1999/05/12  16:51:13  dfg
c  Added a common block DFGRADF for fine grid radical array.
c
c  Revision 1.5  1999/05/03  18:42:58  gem
c  added additional fine grid arrays
c
c  Revision 1.3  1995/04/26  00:47:10  tcm
c  	added kvmap to keep track of correspondence of layers between grids
c
c  Revision 1.2  94/02/10  21:04:05  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c      ixfb, ixfe - first and last x cell of coarse grid
c                   to be divided into fine grid cells
c
c      jyfb, jyfe - first and last y cell of coasre grid 
c                   to be divided into fine grid cells
c
c      nhf, nvf   - number of fine grid cells per coarse
c                   grid cell horizontally and vertically
c
c      nfx, nfy   - number of cells in x and y direction in fine
c                   grid
c
c      nfz        - number of layers in fine grid
c
c      kvmap      - correspondence of fine grid layers with 
c                   layers in grid surrounding it
c
c      delfx, delfy - cell size in x and y dircetions
c
c      tphioaf    - tangent(phi)/earth's radius forfin grids
c   
c      ff0, ff1   - arrays of interpolation factors
c
c      ifavg, ifinst - output unit numbers for average and inst concs
c
c      ifmdf  - fine grid input units for mdf
c
c      ifkv   - fine grid input units for kv
c
c      ifzp   - fine grid input units for zp
c
c      iftemp - fine grid input units for temp
c
c      ifuh2o - fine grid input units for h2o
c
c      ifrain - fine grid input units for rain
c
c      ifcld  - fine grid input units for cloud
c
c      ifaem1,2,3 - fine grid input units for weekday, saturday,
c                   and sunday emissions
c
c      ifgptr - points to fine grid number in which this grid
c               is nested (if 0, then this grid is only within
c               the coarse grid)
c
c      ifglvl - depth at which this grid is nested (1 means within
c               coarse grid only, 2 is within one other fine grid,
c               3 is within a fine grid which is within another
c               fine grid and so forth.)
c
c      ndfcom - number of sub-steps completed on this fine grid
c
c      ndftot - total number of sub-steps needed to complete a
c               coarse grid step on this fine grid
c
c      ndfmax - maximum number of sub-steps to take on this pass
c
c      deltf  - size of the sub-step on this grid
c
      common /deffin/ numfin, ixfb(maxfin), ixfe(maxfin), 
     &                jyfb(maxfin), jyfe(maxfin), 
     &                nhf(maxfin), nvf(maxfin),
     &                nfx(maxfin), nfy(maxfin),
     &                nfz(maxfin), kvmap(mxfz,maxfin),
     &                delfx(mxfy,maxfin), delfy(maxfin),
     &                tphioaf(mxfy,maxfin),
     &                ff0(maxdiv), ff1(maxdiv),
     &                ifavg, ifinst, ifmdf(maxfin), ifkv(maxfin),
     &                ifzp(maxfin), iftemp(maxfin),
     &                ifuh2o(maxfin), ifrain(maxfin),
     &                ifcld(maxfin),
     &                ifaem1(maxfin), ifaem2(maxfin), ifaem3(maxfin),
     &                ifaem(maxfin), ifsrf(maxfin),
     &                ifgptr(maxfin), ifglvl(maxfin), 
     &                ndfcom(maxfin), ndftot(maxfin), ndfmax(maxfin),
     &                deltf(maxfin)
c
c     common /dfgradf/radconf(mxfxby*mxfz*mxrads,maxfin)
      common /dfgradf/radconf(13,maxfin,mxfxby*mxfz)

