      subroutine eftot(nxf,nyf,nfspec,qfarea,ifine,idebug)
c
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: eftot.f,v $
c  Revision 1.3  1995/04/26  00:37:41  tcm
c  	skip unmodeled species in emissions totals
c
c  Revision 1.2  94/02/10  20:54:59  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c

c     routine suns sources for a fine grid and write totals
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'efcon.cmd'
      dimension qfarea(nxf,nyf,nfspec)
c
      do 50 ll=1,nfemit(ifine)
        l=kfemit(ll,ifine)
	if ( l .le. 0 ) goto 50
        tfarea(l,ifine)=0.0
        do 40 j=1,nyf
          do 30 i=1,nxf
             tfarea(l,ifine)=tfarea(l,ifine)+qfarea(i,j,ll)
   30     continue
   40   continue
   50 continue
      write(8,'(a,i5)') 'Emission totals for fine grid ',ifine
      write(8,3900) (tfarea(i,ifine),i=1,mxspec)
 3900 format(' TFAREA= ',11(1pe12.4),/,8x,11(1pe12.4))
      return
      end
