      subroutine fgmax(nxf,nyf,nzf,uf,vf,umax,vmax)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: fgmax.f,v $
c  Revision 1.2  1994/02/10  20:55:40  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  calculates maximum u and v components on a fine grid
c  (tcm,5/9/91)
c
      dimension uf(nxf,nyf,nzf), vf(nxf,nyf,nzf)
c
c  calculate maximum absolute x and y component of wind speed
c
      umax = -999.
      vmax = -999.
      do 100 k=1,nzf
        do 90 j=2,nyf-1
          do 80 i=2,nxf-1
            umax = amax1(abs(uf(i,j,k)),umax)
            vmax = amax1(abs(vf(i,j,k)),vmax)
   80     continue
   90   continue
  100 continue
c
      return
      end
