      subroutine get_final(id,nxf,nyf,nzf,nspecf,cncf,ifine)
c
c$Log: get_final.f,v $
c  Revision 1.1  1999/07/07  00:48:15  tcm
c  Initial revision
c
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'irmb.cmd'
      dimension cncf(nxf,nyf,nspecf,nzf)
c
c  initialize the coarse grid cells for IPRAM
c
      if (id .eq. 1) then
         do k=1,nlayer
            do l=1,nospec
               do j=1,noy
                  do i=1,nox
                     iflg=iflag(i,j)
                     if (iflg.gt.0) then
                        final(iflg,l,k) = conc(i,j,l,k)
                     endif
                  enddo
               enddo
            enddo
         enddo
      endif
c
c  initialize the fine grid cells for IPRAM
c
      if (id .eq. 2) then
         do k=1,nzf
            do l=1,nspecf
               do j=1,nyf
                  do i=1,nxf
                     iflgf=iflagf(i,j,ifine)
                     if (iflgf.gt.0) then
                        finalf(iflgf,l,k) = cncf(i,j,l,k)
                     endif
                  enddo
               enddo
            enddo
         enddo
      endif
c
      return
      end
