      subroutine gunit(iunit,time,ndate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: gunit.f,v $
c  Revision 1.3  1998/11/04  01:41:26  tcm
c  Revised date treatment to handle calendar dates past 1999 and
c  to default Julian dates to 1951 to 2050.
c
c  Revision 1.2  94/02/10  20:56:53  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c     returns unit for area source emissions file
c     depending on day of week
c
c     iunit = aem1 weekday
c     iunit = aem2 saturday
c     iunit = aem3 sunday
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
c
      iunit=aem1
      if (ndate .lt. 100000) then
        call jtocal(ndate,icdate)
        nyr=icdate/10000
        nmth=icdate/100-nyr*100
        nday=icdate-nmth*100-nyr*10000
      else
        nyr=ndate/10000
        nmth=ndate/100-nyr*100
        nday=ndate-nmth*100-nyr*10000
      endif
      if (nyr .lt. 100) then
        if (nyr .lt. 51) then
          nyr = nyr + 2000
        else
          nyr = nyr + 1900
        endif
      endif
c
      if (time.gt.2398.0) nday=nday+1
      call zellar(nyr,nmth,nday,idofwk)
      if (idofwk.gt.2) return
      if (idofwk.eq.1) iunit=aem2
      if (idofwk.eq.2) iunit=aem3
      return
      end
