      subroutine mascal
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: mascal.f,v $
c  Revision 1.2  1994/02/10  20:58:15  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
c-----------------------
c     Quick mass budget calculation
c     (note: FAC has a factor of 1.E3 to account for
c     conversion of micromoles to moles (1.E-6) and 
c     for conversion of cu. km to cu m (1.E9)
c-----------------------
      do 5534 l=1,nospec
        tmas(l) = 0.
        do 5533 k=1,nlayer
          do 5531 j=1,noy
            if (istr(j) .gt. nox) go to 5531
            do 5530 i=istr(j)+1,iend(j)-1
              if (k .eq. 1) then
                hdel = h(i,j,1)
              else
                hdel = h(i,j,k) - h(i,j,k-1)
              endif
              fac = deltax(j)*deltay*hdel*1.e3
              tmas(l) = tmas(l)+conc(i,j,l,k)*fac
 5530       continue
 5531     continue
 5533   continue
 5534 continue
      return
      end
