      function ndaysub(ndate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c
c     ***  subtracts 1 from the calendar date
c
      dimension  ntab(12)
      data  ntab / 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /
c
      nyr=ndate/10000
      nmo=(ndate-nyr*10000)/100
      nday=ndate-nyr*10000-nmo*100
c
      if (mod(nyr,4) .eq. 0) then
        ntab(2) = 29
      else
        ntab(2) = 28
      endif
c
c     ***  add one to the day
c
      nday = nday - 1
c
      if (nday.lt.1) then
c
c     ***  it must be the previous month
c
        nmo = nmo - 1
c
c     ***  happy old year
c
        if (nmo.lt.1) then
          nmo = 12
          nyr = nyr - 1
        endif
        nday = ntab(nmo)
c
      endif
c
c     ***  set up new date
c
      ndaysub=nday+100*nmo+10000*nyr
c
      return
      end
