c
c  parameters for fine grid arrays
c
c$Log: parfin.cmd,v $
c  Revision 1.7  2000/07/03  21:48:29  tcm
c  Increased maximum dimensions of fine grids.
c
c  Revision 1.6  1999/05/13  23:43:27  gem
c  changed parameters for GCOS application
c
c  Revision 1.5  1998/11/04  02:11:49  tcm
c  Increased number of layers to 10.
c
c  Revision 1.4  1996/06/14  23:08:17  tcm
c  see comments below
c
c  Revision 1.3  94/05/20  17:45:16  tcm
c  Increased maxdiv to 32
c
c  Revision 1.2  94/02/10  21:04:55  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c  Set parameters for OTAG modeling   gem  96/02/07
c
c
c    maxfin = maximum number of fine grids
c
c    maxdiv = maximum number of subdivisions of coarse grid
c             (i.e., maximum ratio of coarse grid cell size
c              to fine grid cell size)
c    mxfx   = max number of cells in x direction in fine grid
c    mxfy   = max number of cells in y direction in fine grid
c    mxfz   = max number of layers in fine grids
c    mxfxy  = larger of mxfx and mxfy
c    mxfxby = maximum number of cells in fine grid (nx*ny)
c
      parameter (maxfin = 5)
      parameter (maxdiv = 18)
      parameter (mxfx = 173)
      parameter (mxfy = 120)
      parameter (mxfz = 8)
      parameter (mxfxy = 173)
      parameter (mxfxby = 18000)
c
