      SUBROUTINE RADJRAT(NOSPEC,HH,HR,RATE, JAC)
c
c   *** Generated from DFG's VBChemG software, Dongfen Gao, 5/18/1999
c
c
c$Log: radjrat.f,v $
c Revision 1.1  1999/07/06  20:55:23  dfg
c Initial revision
c
c

      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  RATE(MXSPEC), HH(MXSPEC), HR(MXRADS)
      DIMENSION  JAC(MXSPEC,MXSPEC)
      REAL JAC
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO = HH(KNO)
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      TO2 = HR(KTO2)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out rate and jac for radical species
c 
       do 200 i=1,nospec
         rate(i) = 0. 
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the Jacobian for rad Species
c
      Sink =   - rk(10)  - rk(11)*H2O
      Source = 1.*rk(9)*O3
      Rate(kO1D) = Source + Sink*O1D
      Sink =   - rk(2)  - rk(4)*NO2  - rk(5)*NO2
     &   - rk(6)*NO  - rk(40)*HCHO  - rk(42)*ACET
     &   - rk(56)*OLE  - rk(60)*ETH  - rk(75)*ISOP
     &   - rk(90)*ALDX  - rk(94)*IOLE
      Source = 1.*rk(1)*NO2 +1.*rk(8)*O3
     &  +1.*rk(10)*O1D +.89*rk(14)*NO3
     &  +.5*rk(96)*IOLE*O3
      Rate(kO) = Source + Sink*O
      Sink =   - rk(14)  - rk(15)*NO  - rk(16)*NO2
     &   - rk(17)*NO2  - rk(41)*HCHO  - rk(44)*ACET
     &   - rk(59)*OLE  - rk(67)*CRES  - rk(78)*ISOP
     &   - rk(83)*ETOH  - rk(85)*MEOH  - rk(92)*ALDX
     &   - rk(97)*IOLE  - rk(107)*ISPD
      Source = 1.*rk(5)*O*NO2 +1.*rk(7)*NO2*O3
     &  +1.*rk(19)*N2O5 +1.*rk(27)*OH*HNO3
      Rate(kNO3) = Source + Sink*NO3
      Sink =   - rk(18)*H2O  - rk(19)
      Source = 1.*rk(17)*NO3*NO2
      Rate(kN2O5) = Source + Sink*N2O5
      Sink =   - rk(13)*O3  - rk(28)*NO  - rk(29)*NO2
     &   - rk(32)*HO2  - rk(32)*HO2  - rk(33)*HO2*H2O
     &   - rk(33)*HO2*H2O  - rk(50)*C2O3  - rk(86)*XO2
     &   - rk(87)*XO2N  - rk(102)*CXO3  - rk(104)*OH
      Source = 1.*rk(12)*O3*OH +1.*rk(30)*PNA
     &  +1.*rk(35)*OH*H2O2 +1.*rk(36)*OH*CO
     &  +1.*rk(37)*HCHO*OH +2.*rk(38)*HCHO
     &  +1.*rk(40)*HCHO*O +1.*rk(41)*HCHO*NO3
     &  +2.*rk(45)*ACET +1.*rk(46)*C2O3*NO
     &  +2.*rk(49)*C2O3*C2O3 +1.*rk(51)*CH4*OH
     &  +.11*rk(52)*PAR*OH +.94*rk(53)*ROR
     &  +1.*rk(54)*ROR +.38*rk(56)*O*OLE
     &  +1.*rk(57)*OH*OLE +.44*rk(58)*O3*OLE
     &  +1.7*rk(60)*O*ETH +1.*rk(61)*OH*ETH
     &  +.12*rk(62)*O3*ETH +.44*rk(63)*TOL*OH
     &  +.9*rk(64)*TO2*NO +1.*rk(65)*TO2
     &  +.6*rk(66)*OH*CRES +1.*rk(69)*OPEN
     &  +2.*rk(70)*OPEN*OH +.76*rk(71)*OPEN*O3
     &  +.7*rk(72)*OH*XYL +1.*rk(74)*MGLY
     &  +.25*rk(75)*O*ISOP +.912*rk(76)*OH*ISOP
     &  +.066*rk(77)*O3*ISOP +.8*rk(78)*NO3*ISOP
     &  +1.*rk(82)*ETOH*OH +1.*rk(83)*ETOH*NO3
     &  +1.*rk(84)*MEOH*OH +1.*rk(85)*MEOH*NO3
     &  +2.*rk(93)*ALDX +.1*rk(94)*IOLE*O
     &  +1.*rk(95)*IOLE*OH +.5*rk(96)*IOLE*O3
     &  +1.*rk(97)*IOLE*NO3 +1.*rk(98)*CXO3*NO
     &  +2.*rk(101)*CXO3*C2O3 +.503*rk(105)*OH*ISPD
     &  +.154*rk(106)*O3*ISPD +.925*rk(107)*NO3*ISPD
     &  +1.033*rk(108)*ISPD +.8*rk(109)*NO2*ISOP
     &  +.98*rk(110)*MTBE*OH +1.*rk(111)*SO2*OH
      Rate(kHO2) = Source + Sink*HO2
      Sink =   - rk(12)*O3  - rk(22)*NO  - rk(24)*HNO2
     &   - rk(26)*NO2  - rk(27)*HNO3  - rk(31)*PNA
     &   - rk(35)*H2O2  - rk(36)*CO  - rk(37)*HCHO
     &   - rk(43)*ACET  - rk(51)*CH4  - rk(52)*PAR
     &   - rk(57)*OLE  - rk(61)*ETH  - rk(63)*TOL
     &   - rk(66)*CRES  - rk(70)*OPEN  - rk(72)*XYL
     &   - rk(73)*MGLY  - rk(76)*ISOP  - rk(82)*ETOH
     &   - rk(84)*MEOH  - rk(91)*ALDX  - rk(95)*IOLE
     &   - rk(103)*PANX  - rk(104)*HO2  - rk(105)*ISPD
     &   - rk(110)*MTBE  - rk(111)*SO2
      Source = 2.*rk(11)*O1D*H2O +1.*rk(13)*O3*HO2
     &  +1.*rk(23)*HNO2 +1.*rk(28)*HO2*NO
     &  +2.*rk(34)*H2O2 +1.*rk(40)*HCHO*O
     &  +1.*rk(42)*ACET*O +.2*rk(56)*O*OLE
     &  +.1*rk(58)*O3*OLE +.3*rk(60)*O*ETH
     &  +.08*rk(71)*OPEN*O3 +.266*rk(77)*O3*ISOP
     &  +1.*rk(90)*ALDX*O +.5*rk(96)*IOLE*O3
     &  +.268*rk(106)*O3*ISPD
      Rate(kOH) = Source + Sink*OH
      Sink =   - rk(46)*NO  - rk(47)*NO2  - rk(49)*C2O3
     &   - rk(49)*C2O3  - rk(50)*HO2  - rk(101)*CXO3
      Source = 1.*rk(42)*ACET*O +1.*rk(43)*ACET*OH
     &  +1.*rk(44)*ACET*NO3 +1.*rk(48)*PAN
     &  +1.*rk(69)*OPEN +1.*rk(70)*OPEN*OH
     &  +.62*rk(71)*OPEN*O3 +1.*rk(73)*OH*MGLY
     &  +1.*rk(74)*MGLY +.21*rk(105)*OH*ISPD
     &  +.114*rk(106)*O3*ISPD +.267*rk(108)*ISPD
      Rate(kC2O3) = Source + Sink*C2O3
      Sink =   - rk(98)*NO  - rk(99)*NO2  - rk(101)*C2O3
     &   - rk(102)*HO2
      Source = .25*rk(75)*O*ISOP +.2*rk(77)*O3*ISOP
     &  +1.*rk(90)*ALDX*O +1.*rk(91)*ALDX*OH
     &  +1.*rk(92)*ALDX*NO3 +1.*rk(100)*PANX
     &  +.288*rk(105)*OH*ISPD +.075*rk(107)*NO3*ISPD
     &  +.7*rk(108)*ISPD
      Rate(kCXO3) = Source + Sink*CXO3
      Sink =   - rk(79)*NO  - rk(80)*XO2  - rk(80)*XO2
     &   - rk(86)*HO2  - rk(89)*XO2N
      Source = 1.*rk(45)*ACET +1.*rk(46)*C2O3*NO
     &  +2.*rk(49)*C2O3*C2O3 +1.*rk(51)*CH4*OH
     &  +.87*rk(52)*PAR*OH +.96*rk(53)*ROR
     &  +.28*rk(56)*O*OLE +1.*rk(57)*OH*OLE
     &  +.22*rk(58)*O3*OLE +.91*rk(59)*NO3*OLE
     &  +.7*rk(60)*O*ETH +1.*rk(61)*OH*ETH
     &  +.08*rk(63)*TOL*OH +.9*rk(64)*TO2*NO
     &  +.6*rk(66)*OH*CRES +1.*rk(70)*OPEN*OH
     &  +.03*rk(71)*OPEN*O3 +.5*rk(72)*OH*XYL
     &  +1.*rk(73)*OH*MGLY +.25*rk(75)*O*ISOP
     &  +.991*rk(76)*OH*ISOP +.2*rk(77)*O3*ISOP
     &  +1.*rk(78)*NO3*ISOP +.05*rk(82)*ETOH*OH
     &  +1.*rk(93)*ALDX +.1*rk(94)*IOLE*O
     &  +1.*rk(95)*IOLE*OH +1.*rk(98)*CXO3*NO
     &  +2.*rk(101)*CXO3*C2O3 +.713*rk(105)*OH*ISPD
     &  +.064*rk(106)*O3*ISPD +.075*rk(107)*NO3*ISPD
     &  +.7*rk(108)*ISPD +1.*rk(109)*NO2*ISOP
     &  +1.37*rk(110)*MTBE*OH
      Rate(kXO2) = Source + Sink*XO2
      Sink =   - rk(81)*NO  - rk(87)*HO2  - rk(88)*XO2N
     &   - rk(88)*XO2N  - rk(89)*XO2
      Source = .13*rk(52)*PAR*OH +.04*rk(53)*ROR
     &  +.02*rk(56)*O*OLE +.09*rk(59)*NO3*OLE
     &  +.1*rk(64)*TO2*NO +.088*rk(76)*OH*ISOP
     &  +.02*rk(110)*MTBE*OH
      Rate(kXO2N) = Source + Sink*XO2N
      Sink =   - rk(64)*NO  - rk(65)
      Source = .56*rk(63)*TOL*OH +.3*rk(72)*OH*XYL
      Rate(kTO2) = Source + Sink*TO2
      Sink =   - rk(53)  - rk(54)  - rk(55)*NO2
      Source = .76*rk(52)*PAR*OH +.02*rk(53)*ROR
      Rate(kROR) = Source + Sink*ROR
      Sink =   - rk(68)*NO2
      Source = .4*rk(66)*OH*CRES +1.*rk(67)*CRES*NO3
      Rate(kCRO) = Source + Sink*CRO
c
c--------Now calculate the Jacobian for radicals.
c
      JAC(kO1D, kO1D) =  - rk(10) - rk(11)*H2O
      JAC(kO, kO1D) =  +1.*rk(10)
      JAC(kO, kO) =  - rk(2) - rk(4)*NO2
     $  - rk(5)*NO2 - rk(6)*NO
     $  - rk(40)*HCHO - rk(42)*ACET
     $  - rk(56)*OLE - rk(60)*ETH
     $  - rk(75)*ISOP - rk(90)*ALDX
     $  - rk(94)*IOLE
      JAC(kO, kNO3) =  +.89*rk(14)
      JAC(kNO3, kO) =  +1.*rk(5)*NO2
      JAC(kNO3, kNO3) =  - rk(14) - rk(15)*NO
     $  - rk(16)*NO2 - rk(17)*NO2
     $  - rk(41)*HCHO - rk(44)*ACET
     $  - rk(59)*OLE - rk(67)*CRES
     $  - rk(78)*ISOP - rk(83)*ETOH
     $  - rk(85)*MEOH - rk(92)*ALDX
     $  - rk(97)*IOLE - rk(107)*ISPD
      JAC(kNO3, kN2O5) =  +1.*rk(19)
      JAC(kNO3, kOH) =  +1.*rk(27)*HNO3
      JAC(kN2O5, kNO3) =  +1.*rk(17)*NO2
      JAC(kN2O5, kN2O5) =  - rk(18)*H2O - rk(19)
      JAC(kHO2, kO) =  +1.*rk(40)*HCHO +.38*rk(56)*OLE
     $  +1.7*rk(60)*ETH +.25*rk(75)*ISOP
     $  +.1*rk(94)*IOLE
      JAC(kHO2, kNO3) =  +1.*rk(41)*HCHO +.8*rk(78)*ISOP
     $  +1.*rk(83)*ETOH +1.*rk(85)*MEOH
     $  +1.*rk(97)*IOLE +.925*rk(107)*ISPD
      JAC(kHO2, kHO2) =  - rk(13)*O3 - rk(28)*NO
     $  - rk(29)*NO2 - rk(32)*HO2
     $  - rk(32)*HO2 - rk(32)*HO2
     $  - rk(32)*HO2 - rk(33)*HO2*H2O
     $  - rk(33)*HO2*H2O - rk(33)*HO2*H2O
     $  - rk(33)*HO2*H2O - rk(50)*C2O3
     $  - rk(86)*XO2 - rk(87)*XO2N
     $  - rk(102)*CXO3 - rk(104)*OH
      JAC(kHO2, kOH) =  - rk(104)*HO2 +1.*rk(12)*O3
     $  +1.*rk(35)*H2O2 +1.*rk(36)*CO
     $  +1.*rk(37)*HCHO +1.*rk(51)*CH4
     $  +.11*rk(52)*PAR +1.*rk(57)*OLE
     $  +1.*rk(61)*ETH +.44*rk(63)*TOL
     $  +.6*rk(66)*CRES +2.*rk(70)*OPEN
     $  +.7*rk(72)*XYL +.912*rk(76)*ISOP
     $  +1.*rk(82)*ETOH +1.*rk(84)*MEOH
     $  +1.*rk(95)*IOLE +.503*rk(105)*ISPD
     $  +.98*rk(110)*MTBE +1.*rk(111)*SO2
      JAC(kHO2, kC2O3) =  - rk(50)*HO2 +1.*rk(46)*NO
     $  +2.*rk(49)*C2O3 +2.*rk(49)*C2O3
     $  +2.*rk(101)*CXO3
      JAC(kHO2, kCXO3) =  - rk(102)*HO2 +1.*rk(98)*NO
     $  +2.*rk(101)*C2O3
      JAC(kHO2, kXO2) =  - rk(86)*HO2
      JAC(kHO2, kXO2N) =  - rk(87)*HO2
      JAC(kHO2, kTO2) =  +.9*rk(64)*NO +1.*rk(65)
      JAC(kHO2, kROR) =  +.94*rk(53) +1.*rk(54)
      JAC(kOH, kO1D) =  +2.*rk(11)*H2O
      JAC(kOH, kO) =  +1.*rk(40)*HCHO +1.*rk(42)*ACET
     $  +.2*rk(56)*OLE +.3*rk(60)*ETH
     $  +1.*rk(90)*ALDX
      JAC(kOH, kHO2) =  - rk(104)*OH +1.*rk(13)*O3
     $  +1.*rk(28)*NO
      JAC(kOH, kOH) =  - rk(12)*O3 - rk(22)*NO
     $  - rk(24)*HNO2 - rk(26)*NO2
     $  - rk(27)*HNO3 - rk(31)*PNA
     $  - rk(35)*H2O2 - rk(36)*CO
     $  - rk(37)*HCHO - rk(43)*ACET
     $  - rk(51)*CH4 - rk(52)*PAR
     $  - rk(57)*OLE - rk(61)*ETH
     $  - rk(63)*TOL - rk(66)*CRES
     $  - rk(70)*OPEN - rk(72)*XYL
     $  - rk(73)*MGLY - rk(76)*ISOP
     $  - rk(82)*ETOH - rk(84)*MEOH
     $  - rk(91)*ALDX - rk(95)*IOLE
     $  - rk(103)*PANX - rk(104)*HO2
     $  - rk(105)*ISPD - rk(110)*MTBE
     $  - rk(111)*SO2
      JAC(kC2O3, kO) =  +1.*rk(42)*ACET
      JAC(kC2O3, kNO3) =  +1.*rk(44)*ACET
      JAC(kC2O3, kHO2) =  - rk(50)*C2O3
      JAC(kC2O3, kOH) =  +1.*rk(43)*ACET +1.*rk(70)*OPEN
     $  +1.*rk(73)*MGLY +.21*rk(105)*ISPD
      JAC(kC2O3, kC2O3) =  - rk(46)*NO - rk(47)*NO2
     $  - rk(49)*C2O3 - rk(49)*C2O3
     $  - rk(49)*C2O3 - rk(49)*C2O3
     $  - rk(50)*HO2 - rk(101)*CXO3
      JAC(kC2O3, kCXO3) =  - rk(101)*C2O3
      JAC(kCXO3, kO) =  +.25*rk(75)*ISOP +1.*rk(90)*ALDX
      JAC(kCXO3, kNO3) =  +1.*rk(92)*ALDX +.075*rk(107)*ISPD
      JAC(kCXO3, kHO2) =  - rk(102)*CXO3
      JAC(kCXO3, kOH) =  +1.*rk(91)*ALDX +.288*rk(105)*ISPD
      JAC(kCXO3, kC2O3) =  - rk(101)*CXO3
      JAC(kCXO3, kCXO3) =  - rk(98)*NO - rk(99)*NO2
     $  - rk(101)*C2O3 - rk(102)*HO2
      JAC(kXO2, kO) =  +.28*rk(56)*OLE +.7*rk(60)*ETH
     $  +.25*rk(75)*ISOP +.1*rk(94)*IOLE
      JAC(kXO2, kNO3) =  +.91*rk(59)*OLE +1.*rk(78)*ISOP
     $  +.075*rk(107)*ISPD
      JAC(kXO2, kHO2) =  - rk(86)*XO2
      JAC(kXO2, kOH) =  +1.*rk(51)*CH4 +.87*rk(52)*PAR
     $  +1.*rk(57)*OLE +1.*rk(61)*ETH
     $  +.08*rk(63)*TOL +.6*rk(66)*CRES
     $  +1.*rk(70)*OPEN +.5*rk(72)*XYL
     $  +1.*rk(73)*MGLY +.991*rk(76)*ISOP
     $  +.05*rk(82)*ETOH +1.*rk(95)*IOLE
     $  +.713*rk(105)*ISPD +1.37*rk(110)*MTBE
      JAC(kXO2, kC2O3) =  +1.*rk(46)*NO +2.*rk(49)*C2O3
     $  +2.*rk(49)*C2O3 +2.*rk(101)*CXO3
      JAC(kXO2, kCXO3) =  +1.*rk(98)*NO +2.*rk(101)*C2O3
      JAC(kXO2, kXO2) =  - rk(79)*NO - rk(80)*XO2
     $  - rk(80)*XO2 - rk(80)*XO2
     $  - rk(80)*XO2 - rk(86)*HO2
     $  - rk(89)*XO2N
      JAC(kXO2, kXO2N) =  - rk(89)*XO2
      JAC(kXO2, kTO2) =  +.9*rk(64)*NO
      JAC(kXO2, kROR) =  +.96*rk(53)
      JAC(kXO2N, kO) =  +.02*rk(56)*OLE
      JAC(kXO2N, kNO3) =  +.09*rk(59)*OLE
      JAC(kXO2N, kHO2) =  - rk(87)*XO2N
      JAC(kXO2N, kOH) =  +.13*rk(52)*PAR +.088*rk(76)*ISOP
     $  +.02*rk(110)*MTBE
      JAC(kXO2N, kXO2) =  - rk(89)*XO2N
      JAC(kXO2N, kXO2N) =  - rk(81)*NO - rk(87)*HO2
     $  - rk(88)*XO2N - rk(88)*XO2N
     $  - rk(88)*XO2N - rk(88)*XO2N
     $  - rk(89)*XO2
      JAC(kXO2N, kTO2) =  +.1*rk(64)*NO
      JAC(kXO2N, kROR) =  +.04*rk(53)
      JAC(kTO2, kOH) =  +.56*rk(63)*TOL +.3*rk(72)*XYL
      JAC(kTO2, kTO2) =  - rk(64)*NO - rk(65)
      JAC(kROR, kOH) =  +.76*rk(52)*PAR
      JAC(kROR, kROR) =  - rk(53) - rk(54)
     $  - rk(55)*NO2 +.02*rk(53)
      JAC(kCRO, kNO3) =  +1.*rk(67)*CRES
      JAC(kCRO, kOH) =  +.4*rk(66)*CRES
      JAC(kCRO, kCRO) =  - rk(68)*NO2
c
      RETURN
      END
