      subroutine sedrat(d,rho,vsed)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: sedrat.f,v $
c  Revision 1.2  1994/02/10  20:59:59  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c**********************************************************************
c
c-----this routine estimates the sedimentation velocity of particles
c
c-----the input parameters are
c----- d = diameter of the particle in m
c----- rho = density of the particle in g/m3
c-----the output is
c----- vsed =  sedimenation velocity of the particle (m/s)
c
c**********************************************************************
c
      data a1,a2,a3,xmean,visc/1.257,0.40,0.55,6.53e-08,1.5e-05/
      data bk,xmu,vk/1.38e-16,1.83e-02,0.4/
      data rhoair,grav/1000.,9.81/
      cc=1.+(2*xmean/d)*(a1 + a2*exp(-a3*d/xmean))
      vsed = grav*d**2*(rho - rhoair)*cc/(18.*xmu)
      return
      end
