      subroutine xmscal(mdx,mdy,mdz,mdspc,nxg,nyg,nzg,
     &                  delx,dely,cnca,hta,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: xmscal.f,v $
c  Revision 1.2  1994/02/10  21:03:02  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
      dimension cnca(mdx,mdy,mdspc,mdz), hta(mdx,mdy,mdz)
      dimension delx(nyg)
c-----------------------
c     quick mass budget calculation for portion of coarse grid
c     covered by a specific fine grid.
c     (note: fac has a factor of 1.e3 to account for
c     conversion of micromoles to moles (1.e-6) and 
c     for conversion of cu. km to cu m (1.e9)
c-----------------------
c
c
c  get start and end cells in coarse grid of this fine grid
c
      ix1 = ixfb(ifine)
      ix2 = ixfe(ifine)
      jy1 = jyfb(ifine)
      jy2 = jyfe(ifine)
c
      do 5530 l=1,nospec
        xtmas(l,ifine) = 0.
        do 5533 k=1,nzg
          do 5534 j=jy1,jy2
            do 5535 i=ix1,ix2
              if (k .eq. 1) then
                hdel = hta(i,j,1)
              else
                hdel = hta(i,j,k) - hta(i,j,k-1)
              endif
              fac = delx(j)*dely*hdel*1.e3
              xtmas(l,ifine) = xtmas(l,ifine)+cnca(i,j,l,k)*fac
 5535       continue
 5534     continue
 5533   continue
 5530 continue
      return
      end
